"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _handlebars = _interopRequireDefault(require("handlebars"));

var _ = require("../");

/**
 * Page class
 * manage HTML generation for page template
 */
var Page = /*#__PURE__*/(0, _createClass2["default"])(
/**
 * Create new page object
 * @param  {Object} params req.params from express route
 * @param  {Object} i18n translation
 * @param  {Function} callback
 * @param  {Boolean} onlyHTML default = true, if false HTML content will be prepared for edition (contains abe attributes)
 * @return {String} HTML page as string
 */
function Page(template, json) {
  var onlyHTML = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;
  (0, _classCallCheck2["default"])(this, Page);
  json = _.abeExtend.hooks.instance.trigger('beforePageJson', json);
  _.abeEngine.instance.content = json;
  this._onlyHTML = onlyHTML;
  this.template = template; // Remove text with attribute "visible=false"

  this.template = _.cmsTemplates.prepare.removeHiddenAbeTag(this.template); // remove abe type="slug" from template

  this.template = this.template.replace(/({{abe.*type=[\'|\"]slug.*}})/g, '');

  if (!this._onlyHTML) {
    // Surrounds each Abe tag (which are text/rich/textarea and not in html attribute) with <abe> tag
    // ie. <title><abe>{{abe type='text' key='meta_title' desc='Meta title' tab='Meta' order='4000'}}</abe></title>
    this.template = _.cmsTemplates.prepare.addAbeHtmlTagBetweenAbeTags(this.template);
    this.template = _.cmsTemplates.prepare.addAbeDataAttrForHtmlAttributes(this.template);
    this.template = _.cmsTemplates.prepare.addAbeDataAttrForHtmlTag(this.template);
    this.template = _.cmsTemplates.prepare.addAbeSourceComment(this.template, json);
  } else {
    this.template = _.cmsTemplates.prepare.removeHandlebarsRawFromHtml(this.template);
  } // je rajoute les index pour chaque bloc lié à un each


  this.template = _.cmsTemplates.prepare.indexEachBlocks(this.template, json, this._onlyHTML); // We remove the {{abe type=data ...}} from the text

  this.template = _.cmsData.source.removeDataList(this.template); // It's time to replace the [index] by {{@index}} (concerning each blocks)

  this.template = _.cmsTemplates.prepare.replaceAbeEachIndex(this.template); // I compile the text

  var compiledTemplate = _handlebars["default"].compile(_.cmsTemplates.insertDebugtoolUtilities(this.template, this._onlyHTML)); // I create the html page ! yeah !!!


  this.html = compiledTemplate(json, {
    data: {
      intl: _.config.intlData,
      config: _.config
    }
  });

  if (this._onlyHTML) {
    this.html = _.abeExtend.hooks.instance.trigger('afterPageSaveCompile', this.html, json);
  } else {
    this.html = _.abeExtend.hooks.instance.trigger('afterPageEditorCompile', this.html, json);
  }
});
exports["default"] = Page;