"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _ = require("../../");

var captureAttr = '-abe-([a-z A-Z]{1}[0-9]{1}.+?)(?=.';
/**
 * Class Attr
 * Work string to manage string attributes key/value
 */

var Attr = /*#__PURE__*/function () {
  /**
   * @param  {String} str string to work with
   * @return {void}
   */
  function Attr(str) {
    (0, _classCallCheck2["default"])(this, Attr);
    this.str = str;
    this.val = {};
    this.extract();
  }
  /**
   * @return {Object} attributes extracted from string as an object
   */


  (0, _createClass2["default"])(Attr, [{
    key: "extract",
    value: function extract() {
      var rex = new RegExp(captureAttr + this.getExtension() + ')');

      if (rex.test(this.str)) {
        var arrAttr = this.str.match(rex)[0].replace('-abe-', '');
        this.val = {
          s: arrAttr[0],
          d: _.cmsData.revision.getStatusAndDateToFileName(arrAttr.slice(1))
        };
      }

      return this.val;
    }
    /**
     * @return {String} str without attributes
     */

  }, {
    key: "remove",
    value: function remove() {
      if (this.str != null) {
        return this.str.replace(new RegExp(captureAttr + this.getExtension() + ')'), '');
      }

      return this.str;
    }
  }, {
    key: "getExtension",
    value: function getExtension() {
      if (this.str != null) {
        var ext = this.str.split('.');
        return ext[ext.length - 1];
      }

      return '';
    }
    /**
     * Insert attributes to the string
     * @param  {String} string composed of a status (ex: v for validate, d for draft ...) and a date
     * @return {String} the new string with added attributes
     */

  }, {
    key: "insert",
    value: function insert(newValues) {
      var strWithoutAttr = this.remove();
      strWithoutAttr = strWithoutAttr.replace(new RegExp('\\.' + this.getExtension()), '');
      return strWithoutAttr + '-abe-' + newValues + '.' + this.getExtension();
    }
  }]);
  return Attr;
}();

exports["default"] = Attr;