"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _path = _interopRequireDefault(require("path"));

var _fs = _interopRequireDefault(require("fs"));

var _attr = _interopRequireDefault(require("./attr"));

var _ = require("../../");

/**
 * Class FileAttr
 * Manage string with attributes encoded inside
 */
var FileAttr = /*#__PURE__*/function () {
  function FileAttr() {
    (0, _classCallCheck2["default"])(this, FileAttr);
  }

  (0, _createClass2["default"])(FileAttr, null, [{
    key: "add",
    value:
    /**
     * Add attributes or modify them if they already exists
     * @param {String} str the string to modify
     * @param {Object} options object with attributes to add
     * @return {String} the string with the new attributes
     */
    function add(str, options) {
      var att = new _attr["default"](str);
      return att.insert(options);
    }
    /**
     * Remove attributes from string
     * @param {String} str the string to modify
     * @return {String} the string modified
     */

  }, {
    key: "delete",
    value: function _delete(str) {
      return new _attr["default"](str).remove();
    }
    /**
     * @param  {String} str the string to get attributes from
     * @return {object|String} object (all the attributes) if the key is null, if not the value of the attribute
     */

  }, {
    key: "get",
    value: function get(str) {
      return new _attr["default"](str).val;
    }
    /**
     * @param  {String} str the string to test attributes from
     * @return {boolean} true if string has attr
     */

  }, {
    key: "test",
    value: function test(str) {
      var att = new _attr["default"](str).val;
      return att.s != null;
    }
    /**
     *
     * @param {String} pathFile
     */

  }, {
    key: "getDate",
    value: function getDate(pathFile) {
      var name = _path["default"].basename(pathFile);

      var fileData = _.cmsData.fileAttr.get(name);

      name = _.cmsData.fileAttr["delete"](name);
      var date;

      if (fileData.d) {
        date = fileData.d;
      } else {
        pathFile = _.cmsData.utils.getRevisionPath(pathFile);

        var stat = _fs["default"].statSync(pathFile);

        date = stat.mtime;
      }

      return date;
    }
  }]);
  return FileAttr;
}();

exports["default"] = FileAttr;