"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.add = add;
exports.addAbeTagCollectionToForm = addAbeTagCollectionToForm;
exports.addAbeTagToCollection = addAbeTagToCollection;
exports.addDataAbeTagsToForm = addDataAbeTagsToForm;
exports.addSingleAbeTagsToForm = addSingleAbeTagsToForm;
exports.create = create;
exports.insertAbeEach = insertAbeEach;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _bluebird = require("bluebird");

var _path = _interopRequireDefault(require("path"));

var _ = require("../../");

/**
 * updates the tag value depending on its structure
 * then adds it to the form
 * @param Object tag
 * @param String json
 * @param Array form
 * @returns
 */
function add(tag, json, form) {
  var value = tag.value; // If the key represents an array

  if (tag.key.indexOf('[') > -1) {
    var key = tag.key.split('[')[0];
    var index = tag.key.match(/[^\[]+?(?=\])/)[0];
    var prop = tag.key.replace(/[^\.]+?\./, '');

    try {
      tag.value = eval("json[key][index].".concat(prop));
    } catch (e) {
      try {
        eval("json[key][index].".concat(prop, " = ") + JSON.stringify(value));
      } catch (e) {// no value found inside json KEY
      }
    } // If the key doesn't represent an array

  } else {
    try {
      if (tag.key.indexOf('.') > -1) {
        tag.value = eval("json[\"".concat(tag.key.split('.').join('"]["'), "\"]"));
      } else {
        tag.value = eval("json[\"".concat(tag.key, "\"]"));
      }
    } catch (e) {// no value found inside json KEY
    }
  }

  if (json != null && json.abe_meta != null) {
    tag.status = json.abe_meta.status;
  }

  form.add(tag);
  return tag.value;
}

function addAbeTagToCollection(match, text, json, form, arrayBlock) {
  var keyArray = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : null;
  var i = arguments.length > 6 && arguments[6] !== undefined ? arguments[6] : 0;

  var obj = _.cmsData.attributes.getAll(match, json);

  if (typeof keyArray !== 'undefined' && keyArray !== null) {
    // removes the first part of the key. ie. 'main.article' becomes 'article'
    var realKey = obj.key.replace(/[^\.]+?\./, '');

    if (obj.key.indexOf(keyArray + '.') >= 0 && realKey.length > 0) {
      obj.keyArray = keyArray;
      obj.realKey = realKey;
      obj.key = keyArray + '[' + i + '].' + realKey;
      obj.desc = obj.desc + ' ' + i;
      insertAbeEach(obj, text, json, form, arrayBlock);
    } else if (!form.contains(obj.key)) {
      obj.value = json[obj.key];
      json[obj.key] = add(obj, json, form);
    }
  }
}
/**
 * parse every abe tags,
 * create the defaultValue attribute if it finds a value in 'value' attribute
 * If the abe tag object contains a key and is not already put in the form
 * and is not included in a #each statement, I update its value and
 * add it to the form
 *
 * @param  {[type]} text       [description]
 * @param  {[type]} json       [description]
 * @param  {[type]} form       [description]
 * @return {[type]}            [description]
 */


function addSingleAbeTagsToForm(text, json, form) {
  var match;

  while (match = _.cmsData.regex.abeTag.exec(text)) {
    var matchText = match[0].replace(/value=([\'\"].*?[\'\"])/g, 'defaultValue=$1');

    var obj = _.cmsData.attributes.getAll(matchText, json);

    if (obj.key != '' && obj.type != '' && !form.contains(obj.key) && _.cmsData.regex.isSingleAbe(match, text)) {
      if (json[obj.key]) {
        obj.value = json[obj.key];
      } else {
        obj.value = null;
      }

      add(obj, json, form);
    }
  }
}

function insertAbeEach(obj, text, json, form, arrayBlock) {
  if (typeof arrayBlock[obj.keyArray][obj.realKey] === 'undefined' || arrayBlock[obj.keyArray][obj.realKey] === null) {
    arrayBlock[obj.keyArray][obj.realKey] = [];
  }

  var exist = false;
  Array.prototype.forEach.call(arrayBlock[obj.keyArray][obj.realKey], function (block) {
    if (block.key === obj.key) {
      exist = true;
    }
  });

  if (!exist) {
    arrayBlock[obj.keyArray][obj.realKey].push(obj);
  }
}
/**
 * parse every {{#each name}} texts, then select each abe tag included and create
 * an array of these tags in arrayBlock[name]
 * Then reorder these tags and add them to form
 *
 * @param  {[type]} text       [description]
 * @param  {[type]} json       [description]
 * @param  {[type]} form       [description]
 * @param  {[type]} arrayBlock [description]
 * @return {[type]}            [description]
 */


function addAbeTagCollectionToForm(text, json, form, arrayBlock) {
  var textEach;
  var match;

  while (textEach = _.cmsData.regex.eachBlockPattern.exec(text)) {
    var i;
    var keyArray = textEach[2].split(' ')[0];
    var attrArray = [];
    var length = 0;
    arrayBlock[keyArray] = [];

    while (match = _.cmsData.regex.abeTag.exec(textEach[0])) {
      if (json[keyArray]) {
        for (i = 0; i < json[keyArray].length; i++) {
          addAbeTagToCollection(match[0], text, json, form, arrayBlock, keyArray, i);
        }
      } else {
        addAbeTagToCollection(match[0], text, json, form, arrayBlock, keyArray, 0);
      }
    } // Let's reorder the fields and add it to the form


    for (var index in arrayBlock[keyArray]) {
      attrArray.push(index);
      length = arrayBlock[keyArray][index].length;
    }

    for (i = 0; i < length; i++) {
      for (var j = 0; j < attrArray.length; j++) {
        add(arrayBlock[keyArray][attrArray[j]][i], json, form);
      }
    }
  }
}
/**
 * Removing all type='data' included in {{#each}} statements
 * Then if editable, obj.value = json[obj.key]
 * else put the source values in the json[obj.key]
 * if not editable, put the json value with values from source
 *
 * @param {[type]} text [description]
 * @param {[type]} json [description]
 * @param {[type]} form [description]
 */


function addDataAbeTagsToForm(text, json, form) {
  // removing each blocks potentially containing abe data type
  text = text.replace(_.cmsData.regex.eachBlockPattern, '');

  var dataTags = _.cmsData.regex.getAbeTypeDataList(text);

  Array.prototype.forEach.call(dataTags, function (tagStr) {
    var tag = _.cmsData.attributes.getAll(tagStr, json);

    if (tag.editable) {
      tag.value = json[tag.key];
      add(tag, json, form);
    } else {
      json[tag.key] = tag.source;
    }
  });
}

function create(_x, _x2) {
  return _create.apply(this, arguments);
}

function _create() {
  _create = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(text, json) {
    var precontrib,
        form,
        arrayBlock,
        blocks,
        _args = arguments;
    return _regenerator["default"].wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            precontrib = _args.length > 2 && _args[2] !== undefined ? _args[2] : false;
            form = new _.cmsEditor.form();
            arrayBlock = []; // get all data from type='data' (web service, select, ...)
            // and create a key abe_source with all data
            // get external data from source outside abe types 'data' and 'import'
            // and update json keys with the values
            // + modify keys when editable = false or prefill = true only in the case of source=select

            _context.next = 5;
            return _.cmsData.source.updateJsonWithExternalData(text, json);

          case 5:
            // prepare editor values if editable or put values in json from abe_source
            // (don't do this for type='data' included in {{#each}})
            addDataAbeTagsToForm(text, json, form); // Remove every abe type='data' tags else but those in {{#each}} statements

            text = _.cmsData.source.removeNonEachDataList(text);

            if (!precontrib) {
              text = _.cmsTemplates.template.setAbeSlugDefaultValueIfDoesntExist(text);
              text = _.cmsTemplates.template.setAbePrecontribDefaultValueIfDoesntExist(text);
            } // add abe tags not in each and with a key to the form


            addSingleAbeTagsToForm(text, json, form); // add abe tags in each

            addAbeTagCollectionToForm(text, json, form, arrayBlock);

            if (!precontrib) {
              // HOOKS beforeEditorFormBlocks
              json = _.abeExtend.hooks.instance.trigger('beforeEditorFormBlocks', json, text);
            }

            blocks = form.orderBlock();

            if (!precontrib) {
              // HOOKS afterEditorFormBlocks
              blocks = _.abeExtend.hooks.instance.trigger('afterEditorFormBlocks', blocks, json, text);
            }

            _.abeEngine.instance.content = json;
            return _context.abrupt("return", {
              form: blocks,
              json: json
            });

          case 15:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));
  return _create.apply(this, arguments);
}