"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = abeImport;

var _handlebars = _interopRequireDefault(require("handlebars"));

var _fs = _interopRequireDefault(require("fs"));

var _path = _interopRequireDefault(require("path"));

var _ = require("../../../");

function abeImport(file, config, ctx) {
  file = _.abeExtend.hooks.instance.trigger('beforeImport', file, config, ctx);
  var html = ''; // config de Abe

  config = JSON.parse(config); // le path vers les locales

  var intlData = config.intlData; // le path vers partials

  var defaultPartials = "".concat(__dirname.replace(/\/$/, ''), "/").concat(config.defaultPartials.replace(/\/$/, '')); // si config.custom pas vide, on rajoute ce path to custom

  var custom = config.custom !== '' ? "".concat(config.root.replace(/\/$/, ''), "/").concat(config.custom.replace(/\/$/, '')) : defaultPartials;
  var pathToPartial = "".concat(custom, "/").concat(file, ".html"); // Je cherche d'abord dans custom puis partials
  // pour récupérer le template

  try {
    _fs["default"].statSync(pathToPartial);
  } catch (e) {
    pathToPartial = "".concat(defaultPartials, "/").concat(file, ".html");
  }

  if (_.coreUtils.file.exist(pathToPartial)) {
    html = _fs["default"].readFileSync(pathToPartial, 'utf8');
  } // je recherche les customs de plugins. Si je trouve le fichier aussi dans l'un de ces paths,
  // je rajoute le contenu au html deja obtenu


  var pluginsCustoms = _.abeExtend.plugins.instance.getCustoms();

  Array.prototype.forEach.call(pluginsCustoms, function (pluginCustom) {
    var checkFile = _path["default"].join(pluginCustom, "".concat(file, ".html"));

    if (_.coreUtils.file.exist(checkFile)) {
      html += _fs["default"].readFileSync(checkFile, 'utf8');
    }
  }); // Je fais pareil avec le path des partials des plugins

  var pluginsPartials = _.abeExtend.plugins.instance.getPartials();

  Array.prototype.forEach.call(pluginsPartials, function (pluginPartials) {
    var checkFile = _path["default"].join(pluginPartials, "".concat(file, ".html"));

    if (_.coreUtils.file.exist(checkFile)) {
      html += _fs["default"].readFileSync(checkFile, 'utf8');
    }
  });
  html = _.abeExtend.hooks.instance.trigger('afterImport', html, file, config, ctx); // Et je finis par compiler le template !!!!

  var template = _handlebars["default"].compile(html);

  var res = new _handlebars["default"].SafeString(template(ctx, {
    data: {
      intl: intlData,
      config: config
    }
  }));
  return res;
}