"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = compileAbe;

var _handlebars = _interopRequireDefault(require("handlebars"));

var _abeEngine = _interopRequireDefault(require("./abeEngine"));

var _xss = _interopRequireDefault(require("xss"));

var _ = require("../../../");

/**
 * Abe handlebar helper, that retrieve text to add to handlebars templating engine
 * @return {String} the string to replace {{ handlebars_key }}
 */
function compileAbe() {
  var content = _abeEngine["default"].instance.content;
  if (arguments[0].hash['key'] == null) return '';
  var key;
  var hash;
  var value;
  var testXSS;

  if (arguments[0].hash['key'].indexOf('}-') > 0) {
    key = arguments[0].hash['key'].split('-');
    key = key[key.length - 1];
    hash = arguments[0].hash; // hash.key = hash.key.replace(/\{\{@index\}\}/, '[{{@index}}]')

    hash.key = hash.key.replace(/\{\{@index\}\}/, "[".concat(arguments[0].data.index, "]"));

    try {
      value = content ? eval("content[\"".concat(hash.dictionnary, "\"][").concat(arguments[0].data.index, "].").concat(key)) : hash.key; // value = content ? content[hash['dictionnary']][arguments[0].data.index][key] : hash.key
    } catch (e) {
      console.log(e.stack);
      value = '';
    }

    if (typeof value === 'function' || value == null) {
      value = hash.value != null ? hash.value : '';
    }

    if (hash.type != null && (hash.type === 'rich' || hash.type === 'code')) {
      if (_.config.xss) {
        testXSS = (0, _xss["default"])(value.replace(/&quot;/g, '"'), {
          whiteList: _.config.htmlWhiteList,
          stripIgnoreTag: true
        });
        return new _handlebars["default"].SafeString(testXSS);
      } else {
        return new _handlebars["default"].SafeString(value.replace(/&quot;/g, '"'));
      }
    }

    return value.replace(/%27/, "'");
  }

  key = arguments[0].hash['key'].replace('.', '-');
  hash = arguments[0].hash;

  if (content) {
    try {
      if (hash.key.indexOf('.') > -1) value = eval("content[\"".concat(hash.key.split('.').join('"]["'), "\"]"));else value = eval("content[\"".concat(hash.key, "\"]"));
    } catch (e) {
      value = '';
    }
  } else {
    value = hash.key;
  }

  if (typeof value === 'function' || value == null) {
    value = hash.value != null ? hash.value : '';
  }

  if (hash.type != null && (hash.type === 'rich' || hash.type === 'code')) {
    if (_.config.xss) {
      testXSS = (0, _xss["default"])(value.replace(/&quot;/g, '"'), {
        whiteList: _.config.htmlWhiteList,
        stripIgnoreTag: true
      });
      return new _handlebars["default"].SafeString(testXSS);
    } else {
      return new _handlebars["default"].SafeString(value.replace(/&quot;/g, '"'));
    }
  }

  return value.replace(/%27/, "'");
}