"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = listPage;

var _handlebars = _interopRequireDefault(require("handlebars"));

var _moment = _interopRequireDefault(require("moment"));

var _ = require("../../../");

function listPage(file, index, text) {
  var res = '';
  file = _.abeExtend.hooks.instance.trigger('beforeListPage', file, index, text);
  res += '<tr>';
  res += "<td>".concat((0, _.math)(index, '+', 1), "</td>\n        <td>\n          <a href=\"/abe/editor").concat(file.abe_meta.link, "\" class=\"file-path\">\n            ").concat(file.abe_meta.link, "\n          </a>\n        </td>");

  if (file.abe_meta.template) {
    res += "<td align=\"center\">\n              ".concat(file.abe_meta.template, "\n            </td>");
  } else {
    res += '<td align="center"></td>';
  }

  if (file.date) {
    var dateSearch = (0, _moment["default"])(file.date).utcOffset(0).format('YYYY-MM-DD');
    var dateOrder = new Date(file.date).getTime();
    res += "<td align=\"center\" data-search=\"".concat(dateSearch, "\" data-order=\"").concat(dateOrder, "\">\n              ").concat(dateSearch, "\n            </td>");
  } else {
    res += '<td align="center" data-search="0000-00-00" data-order="0"></td>';
  }

  var workflow = '';
  var status = file.abe_meta.status;
  var workflowUser = _.config.users.workflow;
  Array.prototype.forEach.call(workflowUser, function (flow) {
    var hidden = '';

    if (status !== flow) {
      hidden = 'hidden';
    }

    workflow += "<td align=\"center\" class=\"".concat(flow, "\">");

    if (file[flow]) {
      var fDate = (0, _moment["default"])(file[flow].date).utcOffset(0).format('YYYY-MM-DD HH:mm:ss');

      if (flow === 'publish') {
        workflow += "<a href=\"/abe/editor".concat(file[flow].link, "\" class=\"checkmark label-published\" title=\"").concat(fDate, "\">&#10004;</a>");
      } else {
        workflow += "<a href=\"/abe/editor".concat(file[flow].link, "\" class=\"").concat(hidden, " label label-default label-draft\" title=\"").concat(fDate, "\">").concat(flow, "</a>");
      }
    } else {}

    workflow += '</td>';
  });
  res += workflow;
  res += "<td align=\"center\">\n            <div>";

  if (file.publish != null) {
    res += "<a href=\"/abe/operations/unpublish".concat(file.abe_meta.link, "\"\n               title=\"").concat(text.unpublish, "\"\n               class=\"icon\" data-unpublish=\"true\" data-text=\"").concat(text.confirmUnpublish, " ").concat(file.abe_meta.link, "\"\n               title=\"unpublish\">\n              <span class=\"fa fa-eye-slash\"></span>\n            </a>");
  }

  res += "<a href=\"/abe/operations/delete/".concat(file.abe_meta.status).concat(file.abe_meta.link, "\"\n             title=\"").concat(text["delete"], "\"\n             class=\"icon\"\n             data-delete=\"true\"\n             data-text=\"").concat(text.confirmDelete, " ").concat(file.abe_meta.link, "\"\n             title=\"remove\">\n            <span class=\"fa fa-trash\"></span>\n          </a>");
  res += "\n        </div>\n      </td>\n    </tr>";
  res = _.abeExtend.hooks.instance.trigger('afterListPage', res, file, index, text);
  return new _handlebars["default"].SafeString(res);
}