"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = printBlock;

var _printInput = require("./printInput");

var _abeEngine = _interopRequireDefault(require("./abeEngine"));

function printBlock(ctx, root) {
  var res = '';
  var precontrib = false;

  if (root.precontrib != null) {
    precontrib = root.precontrib;
  }

  if (ctx[0].block != null && ctx[0].block !== '') {
    var tmpContent = '';
    var hidden = true;
    Array.prototype.forEach.call(ctx, function (item) {
      if (item.editable) hidden = false;
      if (precontrib) item.value = '';
      tmpContent += (0, _printInput.printInput)(item, root);
    });
    if (!hidden) res += "<div class=\"form-group\" data-precontrib-templates=\"".concat(ctx[0].precontribTemplate, "\">\n          <div class=\"card\">\n            <h5 class=\"card-header\">").concat(ctx[0].group != null ? ctx[0].group : ctx[0].block, "</h5>\n            <div class='single-block card-body bg-light'>\n      ");else res += "<div class=\"form-group\" data-precontrib-templates=\"".concat(ctx[0].precontribTemplate, "\">\n                <div class='single-block'>");
    res += tmpContent;
    res += '</div></div>';
  } else if (ctx[0].key.indexOf('[') > -1) {
    var ctxBlock = ctx[0].key.split('[')[0];
    res += "<div class=\"form-group\" data-precontrib-templates=\"".concat(ctx[0].precontribTemplate, "\">\n        <div class=\"card\">\n          <h5 class=\"card-header\">").concat(ctxBlock, "\n          <button type=\"button\" class=\"btn btn-success add-block\" title=\"Add new block\" style=\"float: right;\">\n            <span class=\"fa fa-plus\" aria-hidden=\"true\"></span>\n          </button></h5>\n          <div class=\"single-block card-body bg-light\" data-block=\"").concat(ctxBlock, "\">\n      ");
    var arrItem = [];
    Array.prototype.forEach.call(ctx, function (item) {
      var index = item.key.match(/[^\[\]]+?(?=\])/);

      if (arrItem[index] == null) {
        arrItem[index] = [];
      }

      arrItem[index].push(item);
    });
    Array.prototype.forEach.call(Object.keys(arrItem), function (i) {
      var key = arrItem[i][0].key.split('[')[0];
      var display = '';

      if (_abeEngine["default"].instance.content[key] == null || _abeEngine["default"].instance.content[key].length === 0) {
        display = 'style="display: none"';
      }

      res += "<div class=\"list-block\" data-block=\"".concat(key).concat(i, "\" ").concat(display, ">\n                <button type=\"button\" class=\"btn btn-info collapsed\" data-toggle=\"collapse\" data-target=\"#").concat(key).concat(i, "\" >\n                  Section <span class='label-count'>").concat(i, "</span> :\n                  <span class=\"fa fa-chevron-down\" aria-hidden=\"true\"></span>\n                </button>\n                <button type=\"button\" class=\"btn btn-danger remove-block\" title=\"Delete block\" >\n                  <span class=\"fa fa-trash\" aria-hidden=\"true\"></span>\n                </button>\n                <div id=\"").concat(key).concat(i, "\" class=\"collapse\" >\n                ");
      Array.prototype.forEach.call(arrItem[i], function (item) {
        if (precontrib) item.value = '';
        res += (0, _printInput.printInput)(item, root);
      });
      res += '</div></div>';
    });
    res += "\n            </div>\n          </div>\n        </div>";
  } else {
    if (precontrib) ctx[0].value = '';
    res += (0, _printInput.printInput)(ctx[0], root);
  }

  return res;
}