"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = recursiveFolder;

var _path = _interopRequireDefault(require("path"));

function recursiveFolder(obj) {
  var index = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 1;
  var dataShow = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : '';
  var links = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : null;
  var visible = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : false;
  var translate = arguments.length > 5 ? arguments[5] : undefined;
  var classHidden = '';

  if (index > 1 && !visible) {
    classHidden = 'hidden';
  }

  var id = "level-".concat(index);
  var parent = obj[0] ? obj[0].path.split('/')[0] : '';
  var levelText = translate && translate['level-' + index] != null ? translate['level-' + index] : 'Level ' + index;
  var res = "<div class=\"form-group level-".concat(index, " ").concat(classHidden, "\" data-parent=\"").concat(parent, "\" data-shown=\"").concat(dataShow, "\">\n    <label for=\"").concat(id, "\" class=\"control-label\">").concat(levelText, "</label>\n      <select data-precontrib=\"true\" data-slug=\"true\" data-slug-type=\"path\" data-show-hide-sub-folder=\"true\" id=\"").concat(id, "\" data-id=\"").concat(id, "\" class=\"form-control\">\n        <option data-level-hide=\"").concat(index + 1, "\"></option>");
  var sub = '';
  Array.prototype.forEach.call(obj, function (o) {
    var selected = '';
    var isVisible = false;

    var name = _path["default"].basename(o.path);

    if (links != null && links[index - 1] != null) {
      if (links[index - 1] === name) {
        selected = 'selected="selected"';
        isVisible = true;
      }
    }

    res += "<option ".concat(selected, " data-level-hide=\"").concat(index + 2, "\" data-level-show=\"").concat(index + 1, "\" data-show=\"").concat(name.replace(/\.| |\#/g, '_'), "\">").concat(name, "</option>");

    if (o.folders != null && o.folders.length > 0) {
      sub += recursiveFolder(o.folders, index + 1, name.replace(/\.| |\#/g, '_'), links, isVisible, translate);
    }
  });
  res += "</select>\n  </div>";
  res += sub;
  return res;
}