"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
Object.defineProperty(exports, "abeEngine", {
  enumerable: true,
  get: function get() {
    return _abeEngine["default"];
  }
});
Object.defineProperty(exports, "abeImport", {
  enumerable: true,
  get: function get() {
    return _abeImport["default"];
  }
});
Object.defineProperty(exports, "compileAbe", {
  enumerable: true,
  get: function get() {
    return _compileAbe["default"];
  }
});
Object.defineProperty(exports, "createInputFile", {
  enumerable: true,
  get: function get() {
    return _printInput.createInputFile;
  }
});
Object.defineProperty(exports, "createInputImage", {
  enumerable: true,
  get: function get() {
    return _printInput.createInputImage;
  }
});
Object.defineProperty(exports, "createInputLink", {
  enumerable: true,
  get: function get() {
    return _printInput.createInputLink;
  }
});
Object.defineProperty(exports, "createInputRich", {
  enumerable: true,
  get: function get() {
    return _printInput.createInputRich;
  }
});
Object.defineProperty(exports, "createInputSource", {
  enumerable: true,
  get: function get() {
    return _printInput.createInputSource;
  }
});
Object.defineProperty(exports, "createInputText", {
  enumerable: true,
  get: function get() {
    return _printInput.createInputText;
  }
});
Object.defineProperty(exports, "createInputTextarea", {
  enumerable: true,
  get: function get() {
    return _printInput.createInputTextarea;
  }
});
exports.editor = void 0;
Object.defineProperty(exports, "folders", {
  enumerable: true,
  get: function get() {
    return _folders["default"];
  }
});
Object.defineProperty(exports, "form", {
  enumerable: true,
  get: function get() {
    return _form["default"];
  }
});
Object.defineProperty(exports, "getAttributes", {
  enumerable: true,
  get: function get() {
    return _printInput.getAttributes;
  }
});
Object.defineProperty(exports, "getLabel", {
  enumerable: true,
  get: function get() {
    return _printInput.getLabel;
  }
});
Object.defineProperty(exports, "hint", {
  enumerable: true,
  get: function get() {
    return _printInput.hint;
  }
});
Object.defineProperty(exports, "listPage", {
  enumerable: true,
  get: function get() {
    return _listPage["default"];
  }
});
Object.defineProperty(exports, "printBlock", {
  enumerable: true,
  get: function get() {
    return _printBlock["default"];
  }
});
Object.defineProperty(exports, "printConfig", {
  enumerable: true,
  get: function get() {
    return _printConfig["default"];
  }
});
Object.defineProperty(exports, "printInput", {
  enumerable: true,
  get: function get() {
    return _printInput.printInput;
  }
});
Object.defineProperty(exports, "raw", {
  enumerable: true,
  get: function get() {
    return _raw["default"];
  }
});
Object.defineProperty(exports, "recursiveFolder", {
  enumerable: true,
  get: function get() {
    return _recursiveFolder["default"];
  }
});
Object.defineProperty(exports, "recursivePrintConfig", {
  enumerable: true,
  get: function get() {
    return _recursivePrintConfig["default"];
  }
});
Object.defineProperty(exports, "sourceAttr", {
  enumerable: true,
  get: function get() {
    return _sourceAttr["default"];
  }
});
Object.defineProperty(exports, "sourceAutocomplete", {
  enumerable: true,
  get: function get() {
    return _sourceAutocomplete["default"];
  }
});
Object.defineProperty(exports, "sourceOption", {
  enumerable: true,
  get: function get() {
    return _sourceOption["default"];
  }
});

var _handlebars = _interopRequireDefault(require("handlebars"));

var _handlebarsIntl = _interopRequireDefault(require("handlebars-intl"));

var _form = _interopRequireDefault(require("./form"));

var editor = _interopRequireWildcard(require("./editor"));

exports.editor = editor;

var _abeEngine = _interopRequireDefault(require("./handlebars/abeEngine"));

var _abeImport = _interopRequireDefault(require("./handlebars/abeImport"));

var _compileAbe = _interopRequireDefault(require("./handlebars/compileAbe"));

var _folders = _interopRequireDefault(require("./handlebars/folders"));

var _listPage = _interopRequireDefault(require("./handlebars/listPage"));

var _printBlock = _interopRequireDefault(require("./handlebars/printBlock"));

var _printConfig = _interopRequireDefault(require("./handlebars/printConfig"));

var _recursiveFolder = _interopRequireDefault(require("./handlebars/recursiveFolder"));

var _recursivePrintConfig = _interopRequireDefault(require("./handlebars/recursivePrintConfig"));

var _sourceAttr = _interopRequireDefault(require("./handlebars/sourceAttr"));

var _sourceAutocomplete = _interopRequireDefault(require("./handlebars/sourceAutocomplete"));

var _sourceOption = _interopRequireDefault(require("./handlebars/sourceOption"));

var _raw = _interopRequireDefault(require("./handlebars/raw"));

var _printInput = require("./handlebars/printInput");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/* Handlebar abe */
_handlebars["default"].registerHelper('abeImport', _abeImport["default"]);

_handlebars["default"].registerHelper('abe', _compileAbe["default"]);

_handlebars["default"].registerHelper('folders', _folders["default"]);

_handlebars["default"].registerHelper('listPage', _listPage["default"]);

_handlebars["default"].registerHelper('printBlock', _printBlock["default"]);

_handlebars["default"].registerHelper('printConfig', _printConfig["default"]);

_handlebars["default"].registerHelper('printInput', _printInput.printInput);

_handlebars["default"].registerHelper('raw', _raw["default"]);

_handlebarsIntl["default"].registerWith(_handlebars["default"]);