"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _path = _interopRequireDefault(require("path"));

var _fs = _interopRequireDefault(require("fs"));

var _mkdirp = _interopRequireDefault(require("mkdirp"));

var _bluebird = require("bluebird");

var _slugify = _interopRequireDefault(require("slugify"));

var _inquirer = _interopRequireDefault(require("inquirer"));

var _cliColor = _interopRequireDefault(require("cli-color"));

var _surge = _interopRequireDefault(require("surge"));

var _ = require("../../");

var initSite = /*#__PURE__*/function () {
  function initSite() {
    (0, _classCallCheck2["default"])(this, initSite);
  }

  (0, _createClass2["default"])(initSite, [{
    key: "init",
    value: function init(pathSite) {
      var _this = this;

      var p = new _bluebird.Promise(function (resolve) {
        _.Manager.instance.init().then(function () {
          _.Manager.instance.pathTemplates = _path["default"].join(_.config.root, _.config.themes.path, _.config.themes.name, _.config.themes.templates.path);
          _.Manager.instance.pathPartials = _path["default"].join(_.config.root, _.config.themes.path, _.config.themes.name, _.config.themes.partials.path);
          pathSite = pathSite.split(_path["default"].sep);
          pathSite[pathSite.length - 1] = (0, _slugify["default"])(pathSite[pathSite.length - 1], {
            remove: /[$*+~.()'"!\:@§^,;]/g
          });
          pathSite = pathSite.join(_path["default"].sep);

          _this.addFolder(pathSite).then(function () {
            process.chdir(pathSite);

            _this.addFolder(_.config.publish.url);

            _this.addFolder(_.config.structure.url);

            _this.addFolder(_.config.reference.url);

            _this.addFolder(_.config.data.path, true);

            _this.addFolder(_.Manager.instance.pathTemplates.replace(_.config.root + _path["default"].sep, ''));

            _this.addFolder(_.Manager.instance.pathPartials.replace(_.config.root + _path["default"].sep, ''));

            resolve();
          })["catch"](function (e) {
            console.error(e.stack);
            resolve();
          });
        })["catch"](function (e) {
          console.error(e.stack);
          resolve();
        });
      });
      return p;
    }
  }, {
    key: "addFolder",
    value: function addFolder(folder) {
      var addEmptyFile = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
      var p = new _bluebird.Promise(function (resolve) {
        _mkdirp["default"].sync(folder);

        if (addEmptyFile) {
          var filename = _path["default"].join(folder, '.gitkeep');

          _fs["default"].closeSync(_fs["default"].openSync(filename, 'w'));
        }

        resolve();
      });
      return p;
    }
  }, {
    key: "updateSecurity",
    value: function updateSecurity(answers) {
      var p = new _bluebird.Promise(function (resolve) {
        if (answers.security) {
          console.log('Installing Abe security layer');
          var json = {};
          var createLocalConfig = true;

          if (_.config.localConfigExist()) {
            json = _.config.getLocalConfig();
            createLocalConfig = false;
          }

          var confUsers = {
            enable: true
          };

          if (!createLocalConfig) {
            if (typeof json.users === 'undefined' || json.users === null) {
              json.users = confUsers;
            } else {
              if (json.users.enable == false) {
                json.users = confUsers;
              }
            }
          } else {
            json.users = confUsers;
            console.log('Creating a local config file abe.json', _cliColor["default"].cyan.underline('https://github.com/abecms/abecms/blob/master/docs/abe-config.md'));
          }

          _.config.save(json);

          var u = {
            username: answers.username,
            name: answers.username,
            email: answers.email,
            password: answers.password,
            role: {
              workflow: 'admin',
              name: 'Admin'
            }
          };

          _.User.manager.instance.update([]);

          var admin = _.User.operations.add(u);

          if (admin.success == 1) _.User.operations.activate(admin.user.id);else if (admin.xssError) {
            console.log("XSS detected");
            process.exit(1);
          } else if (admin.emailTaken) {
            console.log("Email already in use");
            process.exit(1);
          } else {
            console.log("Data validation error");
            process.exit(1);
          }
        }

        resolve();
      });
      return p;
    }
  }, {
    key: "updateTheme",
    value: function updateTheme(answers) {
      var p = new _bluebird.Promise(function (resolve) {
        if (answers.theme) {
          if (answers.which !== 'Your own template') {
            console.log('installing the theme ' + answers.which);

            _.cmsThemes.themes.downloadTheme('https://github.com/abecms/theme-' + answers.which + '/archive/master.zip', answers.which).then(function (resp) {
              resolve();
            })["catch"](function (e) {
              resolve();
            });
          } else {
            if (answers.url.indexOf('//') > -1) {
              console.log('installing theme from url:' + answers.url);
              resolve();
            } else {
              console.log('installing the theme ' + answers.url + ' from themes.abecms.io');

              _.cmsThemes.themes.downloadTheme('https://github.com/abecms/theme-' + answers.which + '/archive/master.zip', answers.which).then(function (resp) {
                resolve();
              })["catch"](function (e) {
                resolve();
              });
            }
          }
        } else {
          resolve();
        }
      });
      return p;
    }
  }, {
    key: "askDeploymentQuestions",
    value: function askDeploymentQuestions() {
      var p = new _bluebird.Promise(function (resolve) {
        _inquirer["default"].prompt([{
          type: 'confirm',
          name: 'deploy',
          message: 'Do you want to publish your amazing contributions on Internet',
          "default": false
        }, {
          type: 'list',
          name: 'which',
          choices: ["on surge (it's free !)", 'a github repository', 'a S3 bucket', 'via (S)FTP'],
          message: 'Please select a deployment method',
          "default": 0,
          when: function when(answers) {
            return answers.deploy;
          }
        }, {
          type: 'input',
          name: 'domain',
          message: 'Please enter a domain (either your own domain or a domain.surge.sh)',
          when: function when(answers) {
            return answers.which === "on surge (it's free !)";
          }
        }, {
          type: 'input',
          name: 'repository',
          message: 'Please enter the github repository',
          when: function when(answers) {
            return answers.which === 'a github repository';
          }
        }, {
          type: 'input',
          name: 'branch',
          message: 'Please enter the github branch',
          "default": 'master',
          when: function when(answers) {
            return answers.which === 'a github repository';
          }
        }, {
          type: 'input',
          name: 'username',
          message: 'Please enter the github username',
          when: function when(answers) {
            return answers.which === 'a github repository';
          }
        }, {
          type: 'input',
          name: 'email',
          message: 'Please enter the github email',
          when: function when(answers) {
            return answers.which === 'a github repository';
          }
        }, {
          type: 'input',
          name: 'region',
          message: 'Please enter the S3 region',
          "default": 'eu-central-1',
          when: function when(answers) {
            return answers.which === 'a S3 bucket';
          }
        }, {
          type: 'input',
          name: 'accessKeyId',
          message: 'Please enter the S3 accessKeyId',
          when: function when(answers) {
            return answers.which === 'a S3 bucket';
          }
        }, {
          type: 'input',
          name: 'secretAccessKey',
          message: 'Please enter the S3 secretAccessKey',
          when: function when(answers) {
            return answers.which === 'a S3 bucket';
          }
        }, {
          type: 'input',
          name: 'bucket',
          message: 'Please enter the S3 bucket',
          when: function when(answers) {
            return answers.which === 'a S3 bucket';
          }
        }, {
          type: 'input',
          name: 'prefix',
          message: 'Please enter the S3 prefix',
          when: function when(answers) {
            return answers.which === 'a S3 bucket';
          }
        }, {
          type: 'list',
          name: 'protocol',
          choices: ['SFTP', 'FTP'],
          message: 'Please select the protocol',
          "default": 0,
          when: function when(answers) {
            return answers.which === 'via (S)FTP';
          }
        }, {
          type: 'input',
          name: 'host',
          message: 'Please enter the host',
          when: function when(answers) {
            return answers.which === 'via (S)FTP';
          }
        }, {
          type: 'input',
          name: 'remoteDir',
          message: 'Please enter the remote directory',
          when: function when(answers) {
            return answers.which === 'via (S)FTP';
          }
        }, {
          type: 'list',
          name: 'requiresType',
          choices: ['It requires a password', 'It requires a SSH key'],
          message: 'Please select the authentication type',
          "default": 1,
          when: function when(answers) {
            return answers.which === 'via (S)FTP';
          }
        }, {
          type: 'input',
          name: 'username',
          message: 'Please enter the username',
          when: function when(answers) {
            return answers.which === 'via (S)FTP';
          }
        }, {
          type: 'input',
          name: 'password',
          message: 'Please enter the password',
          when: function when(answers) {
            return answers.which === 'via (S)FTP' && answers.requiresType === 'It requires a password';
          }
        }, {
          type: 'input',
          name: 'sshKeyPath',
          message: 'Please enter the ssh KeyPath on your computer (/path/to/id_rsa_pub)',
          when: function when(answers) {
            return answers.which === 'via (S)FTP' && answers.requiresType === 'It requires a SSH key';
          }
        }]).then(function (answers) {
          resolve(answers);
        });
      });
      return p;
    }
  }, {
    key: "askPluginsQuestions",
    value: function askPluginsQuestions() {
      var p = new _bluebird.Promise(function (resolve) {
        _inquirer["default"].prompt([{
          type: 'checkbox',
          name: 'plugins',
          choices: [{
            key: 'a',
            name: 'abe-deployer-git: Deploy your website on GIT',
            value: 'abecms/abe-deployer-git'
          }, {
            key: 'b',
            name: 'abe-deployer-sftp: Deploy your website through FTP or SFTP',
            value: 'abecms/abe-deployer-sftp'
          }, {
            key: 'c',
            name: 'abe-deployer-s3: Deploy your website to S3',
            value: 'abecms/abe-deployer-s3'
          }, {
            key: 'd',
            name: 'abe-packagz: Create individual zip of a post on publish',
            value: 'abecms/abe-packagz'
          }, new _inquirer["default"].Separator(), {
            key: 'e',
            name: 'abe-elasticsearch: Index your posts on ElasticSearch',
            value: 'abecms/abe-elasticsearch'
          }, {
            key: 'f',
            name: 'abe-algolia: Index your posts on Algolia',
            value: 'abecms/abe-algolia'
          }, new _inquirer["default"].Separator(), {
            key: 'g',
            name: 'abe-sitemap: Add a XML Sitemap to your website',
            value: 'abecms/abe-sitemap'
          }, {
            key: 'h',
            name: 'abe-mailer: Create contact Forms on your website and send emails',
            value: 'wonknu/abe-mailer'
          }, {
            key: 'i',
            name: 'abe-rangeslider: Position a abe text with absolute coordinates on images',
            value: 'wonknu/abe-rangeslider'
          }],
          message: 'Select the plugins you want to install'
        }]).then(function (answers) {
          resolve(answers);
        });
      });
      return p;
    }
  }, {
    key: "askQuestions",
    value: function askQuestions() {
      var p = new _bluebird.Promise(function (resolve) {
        _inquirer["default"].prompt([{
          type: 'input',
          name: 'name',
          message: "Enter the name of the project you want to create (only letters and '-' allowed)"
        }, {
          type: 'confirm',
          name: 'theme',
          message: 'Do you want to install a theme ?',
          "default": true
        }, {
          type: 'list',
          name: 'which',
          choices: ['default', 'multiverse', 'lens', 'Your own template'],
          message: 'Please select a theme',
          "default": 0,
          when: function when(answers) {
            return answers.theme;
          }
        }, {
          type: 'input',
          name: 'url',
          message: 'Enter the url of the theme or enter a theme name from ',
          when: function when(answers) {
            return answers.which == 'Your own template' ? true : false;
          }
        }, {
          type: 'confirm',
          name: 'security',
          message: 'Do you activate the user management ?',
          "default": true
        }, {
          type: 'input',
          name: 'username',
          message: 'Enter the username',
          "default": 'admin',
          when: function when(answers) {
            return answers.security;
          }
        }, {
          type: 'input',
          name: 'email',
          message: 'Enter the email address',
          "default": 'admin@test.com',
          when: function when(answers) {
            return answers.security;
          },
          validate: function validate(value) {
            var pass = value.match(_.coreUtils.mail.regexEmail);

            if (pass) {
              return true;
            }

            return 'Please enter a valid email address';
          }
        }, {
          type: 'password',
          name: 'password',
          message: 'Enter the password',
          "default": 'Adm1n@test',
          when: function when(answers) {
            return answers.security;
          },
          validate: function validate(value, answers) {
            var cPassword = _.User.utils.commonPassword({
              username: answers.username,
              password: value
            });

            if (cPassword.success === 0) {
              return 'The password must be at least 10 characters long with no sequences of three or more repeated characters, at least one uppercase letter, one number and one special character.';
            }

            return true;
          }
        }]).then(function (answers) {
          resolve(answers);
        });
      });
      return p;
    }
  }]);
  return initSite;
}();

exports["default"] = initSite;