"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.draft = draft;
exports.publish = publish;
exports.reject = reject;
exports.submit = submit;
exports.unpublish = unpublish;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _path = _interopRequireDefault(require("path"));

var _ = require("../../");

function draft(_x, _x2) {
  return _draft.apply(this, arguments);
}

function _draft() {
  _draft = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(postUrl, json) {
    var workflow,
        user,
        docPath,
        revisionPath,
        date,
        result,
        template,
        success,
        _args = arguments;
    return _regenerator["default"].wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            workflow = _args.length > 2 && _args[2] !== undefined ? _args[2] : 'draft';
            user = _args.length > 3 ? _args[3] : undefined;

            _.abeExtend.hooks.instance.trigger('beforeDraft', json, postUrl);

            docPath = _.cmsData.utils.getDocRelativePathFromPostUrl(postUrl);
            revisionPath = _.coreUtils.file.addDateIsoToRevisionPath(docPath, workflow);
            date = _.coreUtils.file.getDate(revisionPath);
            result = {
              success: 0,
              error: 'cannot json save file'
            };

            _.cmsData.metas.add(json, workflow, date, user);

            template = _.cmsTemplates.template.getTemplate(json.abe_meta.template, json);
            _context.next = 11;
            return _.cmsData.source.updateJsonWithExternalData(template, json);

          case 11:
            json['abe_meta'].complete = _.cmsData.utils.getPercentOfRequiredTagsFilled(template, json);
            _context.next = 14;
            return _.cmsOperations.save.saveJson(revisionPath, json);

          case 14:
            success = _context.sent;

            if (!success) {
              _context.next = 19;
              break;
            }

            _context.next = 18;
            return _.Manager.instance.updatePostInList(revisionPath);

          case 18:
            result = {
              success: 1,
              json: json
            };

          case 19:
            return _context.abrupt("return", result);

          case 20:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));
  return _draft.apply(this, arguments);
}

function publish(_x3, _x4, _x5) {
  return _publish.apply(this, arguments);
}

function _publish() {
  _publish = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee3(postUrl, json, user) {
    var docRelativePath, postPath, template, page, result, relatedTemplates;
    return _regenerator["default"].wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            _.abeExtend.hooks.instance.trigger('beforePublish', json, postUrl);

            docRelativePath = _.cmsData.utils.getDocRelativePathFromPostUrl(postUrl);
            postPath = _path["default"].join(_.Manager.instance.pathPublish, postUrl);

            _.cmsData.metas.add(json, 'publish', null, user);

            template = _.cmsTemplates.template.getTemplate(json.abe_meta.template, json);
            _context3.next = 7;
            return _.cmsData.source.updateJsonWithExternalData(template, json);

          case 7:
            json['abe_meta'].complete = _.cmsData.utils.getPercentOfRequiredTagsFilled(template, json);
            page = new _.Page(template, json, true);

            if (_.cmsOperations.save.saveHtml(postPath, page.html)) {
              _context3.next = 13;
              break;
            }

            result = {
              success: 0,
              error: 'cannot save html file'
            };
            _context3.next = 22;
            break;

          case 13:
            _context3.next = 15;
            return _.cmsOperations.save.saveJson(docRelativePath, json);

          case 15:
            if (_context3.sent) {
              _context3.next = 19;
              break;
            }

            result = {
              success: 0,
              error: 'cannot save json file'
            };
            _context3.next = 22;
            break;

          case 19:
            _.Manager.instance.updatePostInList(docRelativePath);

            _.abeExtend.hooks.instance.trigger('afterPublish', json, postUrl);

            result = {
              success: 1,
              json: json
            };

          case 22:
            if (!json.abe_meta.relatedTemplates) {
              _context3.next = 26;
              break;
            }

            relatedTemplates = Object.keys(json.abe_meta.relatedTemplates);
            _context3.next = 26;
            return Promise.all(relatedTemplates.map( /*#__PURE__*/function () {
              var _ref = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2(key, index) {
                var relatedTemplate, relTemplate, extension, fileName, relPath, _page;

                return _regenerator["default"].wrap(function _callee2$(_context2) {
                  while (1) {
                    switch (_context2.prev = _context2.next) {
                      case 0:
                        relatedTemplate = json.abe_meta.relatedTemplates[key];

                        if (!(relatedTemplate.template && relatedTemplate.path)) {
                          _context2.next = 11;
                          break;
                        }

                        relTemplate = _.cmsTemplates.template.getTemplate(relatedTemplate.template, json);
                        extension = _.config.files.templates.extension;
                        if (relatedTemplate.extension) extension = relatedTemplate.extension;
                        fileName = _path["default"].basename(postUrl, '.' + _.config.files.templates.extension) + '.' + extension;
                        relPath = _path["default"].join(_.Manager.instance.pathPublish, relatedTemplate.path, fileName);
                        _context2.next = 9;
                        return _.cmsData.source.updateJsonWithExternalData(relTemplate, json);

                      case 9:
                        _page = new _.Page(relTemplate, json, true);

                        _.cmsOperations.save.saveHtml(relPath, _page.html);

                      case 11:
                      case "end":
                        return _context2.stop();
                    }
                  }
                }, _callee2);
              }));

              return function (_x16, _x17) {
                return _ref.apply(this, arguments);
              };
            }()));

          case 26:
            return _context3.abrupt("return", result);

          case 27:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3);
  }));
  return _publish.apply(this, arguments);
}

function unpublish(_x6, _x7) {
  return _unpublish.apply(this, arguments);
}

function _unpublish() {
  _unpublish = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee4(postUrl, user) {
    var docPath, postPath, json, result, newDocPath;
    return _regenerator["default"].wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            _.abeExtend.hooks.instance.trigger('beforeUnpublish', postUrl);

            docPath = _.cmsData.utils.getDocPathFromPostUrl(postUrl);
            postPath = _path["default"].join(_.Manager.instance.pathPublish, postUrl);
            _context4.next = 5;
            return _.cmsData.revision.getDoc(docPath);

          case 5:
            json = _context4.sent;

            if (json.abe_meta.publish != null) {
              delete json.abe_meta.publish;
            }

            _context4.next = 9;
            return _.cmsOperations.post.draft(postUrl, json, 'draft', user);

          case 9:
            result = _context4.sent;

            _.cmsOperations.remove.removeRevision(docPath);

            _.cmsOperations.remove.removePost(postPath); // are there additional templates to export?


            if (result.json.abe_meta.relatedTemplates) {
              Object.keys(result.json.abe_meta.relatedTemplates).map(function (key, index) {
                var relatedTemplate = result.json.abe_meta.relatedTemplates[key];

                if (relatedTemplate.template && relatedTemplate.path) {
                  var relTemplate = _.cmsTemplates.template.getTemplate(relatedTemplate.template, json);

                  var extension = _.config.files.templates.extension;
                  if (relatedTemplate.extension) extension = relatedTemplate.extension;
                  var fileName = _path["default"].basename(postUrl, '.' + _.config.files.templates.extension) + '.' + extension;

                  var relatedPostPath = _path["default"].join(_.Manager.instance.pathPublish, relatedTemplate.path, fileName);

                  _.cmsOperations.remove.removePost(relatedPostPath);
                }
              });
            }

            newDocPath = _.cmsData.utils.getDocPathFromLinkStatusDate(result.json);

            _.Manager.instance.updatePostInList(newDocPath);

            _.abeExtend.hooks.instance.trigger('afterUnpublish', docPath, postPath, result.json);

            return _context4.abrupt("return", result.json);

          case 17:
          case "end":
            return _context4.stop();
        }
      }
    }, _callee4);
  }));
  return _unpublish.apply(this, arguments);
}

function submit(_x8, _x9, _x10, _x11) {
  return _submit.apply(this, arguments);
}

function _submit() {
  _submit = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee5(postUrl, json, workflow, user) {
    var result;
    return _regenerator["default"].wrap(function _callee5$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            if (!(workflow === 'publish')) {
              _context5.next = 6;
              break;
            }

            _context5.next = 3;
            return _.cmsOperations.post.publish(postUrl, json, user);

          case 3:
            result = _context5.sent;
            _context5.next = 9;
            break;

          case 6:
            _context5.next = 8;
            return _.cmsOperations.post.draft(postUrl, json, workflow, user);

          case 8:
            result = _context5.sent;

          case 9:
            return _context5.abrupt("return", result);

          case 10:
          case "end":
            return _context5.stop();
        }
      }
    }, _callee5);
  }));
  return _submit.apply(this, arguments);
}

function reject(_x12, _x13, _x14, _x15) {
  return _reject.apply(this, arguments);
}

function _reject() {
  _reject = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee6(filePath, json, workflow, user) {
    var rejectToWorkflow, found, result;
    return _regenerator["default"].wrap(function _callee6$(_context6) {
      while (1) {
        switch (_context6.prev = _context6.next) {
          case 0:
            _.abeExtend.hooks.instance.trigger('beforeReject', filePath);

            found = false;
            Array.prototype.forEach.call(_.config.users.workflow, function (flow) {
              if (workflow === flow) {
                found = true;
              }

              if (!found) {
                rejectToWorkflow = flow;
              }
            });

            if (!found) {
              rejectToWorkflow = 'draft';
            }

            if (json.abe_meta.publish != null) {
              delete json.abe_meta.publish;
            }

            _context6.next = 7;
            return _.cmsOperations.post.draft(filePath, json, rejectToWorkflow, user);

          case 7:
            result = _context6.sent;

            _.abeExtend.hooks.instance.trigger('afterReject', result);

            return _context6.abrupt("return", result);

          case 10:
          case "end":
            return _context6.stop();
        }
      }
    }, _callee6);
  }));
  return _reject.apply(this, arguments);
}