"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.remove = remove;
exports.removePost = removePost;
exports.removeRevision = removeRevision;
exports.removeRevisionFile = removeRevisionFile;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _path = _interopRequireDefault(require("path"));

var _fs = _interopRequireDefault(require("fs"));

var _ = require("../../");

function remove(_x) {
  return _remove.apply(this, arguments);
}

function _remove() {
  _remove = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2(postUrl) {
    var docRelativePath, revisions;
    return _regenerator["default"].wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            postUrl = _.abeExtend.hooks.instance.trigger('beforeDeleteFile', postUrl);
            docRelativePath = _.cmsData.utils.getDocRelativePathFromPostUrl(postUrl);
            revisions = _.cmsData.revision.getVersions(docRelativePath);
            _context2.next = 5;
            return Promise.all(revisions.map( /*#__PURE__*/function () {
              var _ref = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(revision) {
                var postPath;
                return _regenerator["default"].wrap(function _callee$(_context) {
                  while (1) {
                    switch (_context.prev = _context.next) {
                      case 0:
                        postPath = _.cmsData.utils.getPostPath(revision.path);
                        _context.next = 3;
                        return _.cmsOperations.remove.removeRevision(revision.path);

                      case 3:
                        _context.next = 5;
                        return _.cmsOperations.remove.removePost(postPath);

                      case 5:
                      case "end":
                        return _context.stop();
                    }
                  }
                }, _callee);
              }));

              return function (_x5) {
                return _ref.apply(this, arguments);
              };
            }()));

          case 5:
            postUrl = _.abeExtend.hooks.instance.trigger('afterDeleteFile', postUrl, {});

            _.Manager.instance.removePostFromList(postUrl.replace(new RegExp('\\/', 'g'), _path["default"].sep));

          case 7:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));
  return _remove.apply(this, arguments);
}

function removePost(_x2) {
  return _removePost.apply(this, arguments);
}

function _removePost() {
  _removePost = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee3(file) {
    return _regenerator["default"].wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            if (_.coreUtils.file.exist(file)) {
              _fs["default"].rmSync(file);
            }

          case 1:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3);
  }));
  return _removePost.apply(this, arguments);
}

function removeRevision(_x3) {
  return _removeRevision.apply(this, arguments);
}

function _removeRevision() {
  _removeRevision = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee4(jsonPath) {
    var result;
    return _regenerator["default"].wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            result = false;

            if (!(_.config.database.type == "file")) {
              _context4.next = 7;
              break;
            }

            _context4.next = 4;
            return removeRevisionFile(jsonPath);

          case 4:
            result = _context4.sent;
            _context4.next = 11;
            break;

          case 7:
            if (!(_.config.database.type == "mongo")) {
              _context4.next = 11;
              break;
            }

            _context4.next = 10;
            return _.mongo.removeRevision(jsonPath);

          case 10:
            result = _context4.sent;

          case 11:
            return _context4.abrupt("return", result);

          case 12:
          case "end":
            return _context4.stop();
        }
      }
    }, _callee4);
  }));
  return _removeRevision.apply(this, arguments);
}

function removeRevisionFile(_x4) {
  return _removeRevisionFile.apply(this, arguments);
}

function _removeRevisionFile() {
  _removeRevisionFile = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee5(file) {
    return _regenerator["default"].wrap(function _callee5$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            if (!_.coreUtils.file.exist(file)) {
              _context5.next = 3;
              break;
            }

            _context5.next = 3;
            return _fs["default"].rmSync(file);

          case 3:
          case "end":
            return _context5.stop();
        }
      }
    }, _callee5);
  }));
  return _removeRevisionFile.apply(this, arguments);
}