"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.saveHtml = saveHtml;
exports.saveJson = saveJson;
exports.saveJsonFile = saveJsonFile;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _fsExtra = _interopRequireDefault(require("fs-extra"));

var _mkdirp = _interopRequireDefault(require("mkdirp"));

var _xss = _interopRequireDefault(require("xss"));

var _path = _interopRequireDefault(require("path"));

var _ = require("../../");

function saveJson(_x, _x2) {
  return _saveJson.apply(this, arguments);
}

function _saveJson() {
  _saveJson = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(jsonPath, json) {
    var result;
    return _regenerator["default"].wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            result = false;

            if (!(_.config.database.type == "file")) {
              _context.next = 7;
              break;
            }

            _context.next = 4;
            return saveJsonFile(jsonPath, json);

          case 4:
            result = _context.sent;
            _context.next = 11;
            break;

          case 7:
            if (!(_.config.database.type == "mongo")) {
              _context.next = 11;
              break;
            }

            _context.next = 10;
            return _.mongo.saveJson(jsonPath, json);

          case 10:
            result = _context.sent;

          case 11:
            return _context.abrupt("return", result);

          case 12:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));
  return _saveJson.apply(this, arguments);
}

function saveJsonFile(_x3, _x4) {
  return _saveJsonFile.apply(this, arguments);
}

function _saveJsonFile() {
  _saveJsonFile = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2(jsonPath, json) {
    var eachRecursive;
    return _regenerator["default"].wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            jsonPath = _.cmsData.utils.getRevisionPath(jsonPath);

            _mkdirp["default"].sync(_path["default"].dirname(jsonPath));

            if (json.abe_source != null) delete json.abe_source;
            if (json.abeEditor != null) delete json.abeEditor;

            eachRecursive = function eachRecursive(obj) {
              for (var k in obj) {
                if ((0, _typeof2["default"])(obj[k]) === 'object' && obj[k] !== null) {
                  eachRecursive(obj[k]);
                } else if (typeof obj[k] !== 'undefined' && obj[k] !== null) {
                  if (_.config.xss) {
                    obj[k] = (0, _xss["default"])(obj[k].toString().replace(/&quot;/g, '"'), {
                      whiteList: _.config.htmlWhiteList
                    });
                  } else {
                    obj[k] = obj[k].toString().replace(/&quot;/g, '"');
                  }
                }
              }
            };

            eachRecursive(json);

            _fsExtra["default"].writeJsonSync(jsonPath, json, {
              space: 2,
              encoding: 'utf-8'
            });

            return _context2.abrupt("return", true);

          case 8:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));
  return _saveJsonFile.apply(this, arguments);
}

function saveHtml(_x5, _x6) {
  return _saveHtml.apply(this, arguments);
}

function _saveHtml() {
  _saveHtml = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee3(pathFile, html) {
    return _regenerator["default"].wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            _context3.next = 2;
            return (0, _mkdirp["default"])(_path["default"].dirname(pathFile));

          case 2:
            _context3.next = 4;
            return _fsExtra["default"].writeFile(pathFile, html);

          case 4:
            return _context3.abrupt("return", true);

          case 5:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3);
  }));
  return _saveHtml.apply(this, arguments);
}