"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getFiles = getFiles;
exports.saveFile = saveFile;

var _path = _interopRequireDefault(require("path"));

var _fsExtra = _interopRequireDefault(require("fs-extra"));

var _ = require("../../");

function getFiles() {
  var name = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';

  var pathToReferences = _path["default"].join(_.config.root, _.config.reference.url);

  var res = {};
  if (name !== '') res[name] = _.coreUtils.file.getJson(_path["default"].join(pathToReferences, name));else {
    var files = _.coreUtils.file.getFilesSync(pathToReferences, true, '.json');

    Array.prototype.forEach.call(files, function (pathFile) {
      var fileName = pathFile.split(_path["default"].sep);
      res[fileName[fileName.length - 1]] = _.coreUtils.file.getJson(pathFile);
    });
  }
  return res;
}

function saveFile(url, json) {
  _fsExtra["default"].exists(_path["default"].join(_.config.root, _.config.reference.url), function (exists) {
    if (!exists) {
      _fsExtra["default"].mkdir(_path["default"].join(_.config.root, _.config.reference.url), function () {
        _fsExtra["default"].writeJson(_path["default"].join(_.config.root, _.config.reference.url, url), JSON.parse(json), {
          space: 2,
          encoding: "utf-8"
        });
      });
    } else {
      _fsExtra["default"].writeJson(_path["default"].join(_.config.root, _.config.reference.url, url), JSON.parse(json), function (err) {
        if (err) console.log('saveFile reference error: ', err);
      });
    }
  });
}