"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.editStructure = editStructure;
exports.list = list;

var _ = require("../../");

var _fsExtra = _interopRequireDefault(require("fs-extra"));

var _path = _interopRequireDefault(require("path"));

function editStructure(type, folderPath) {
  var oldFolderPath = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
  if (type === 'add') _.coreUtils.file.addFolder(folderPath);else if (type === 'rename') _.coreUtils.file.renameFolder(oldFolderPath, folderPath);else _.coreUtils.file.removeFolder(folderPath);
  return folderPath;
}

function list(dir) {
  var walk = function walk(entry) {
    return new Promise(function (resolve, reject) {
      _fsExtra["default"].exists(entry, function (exists) {
        if (!exists) {
          return resolve({});
        }

        return resolve(new Promise(function (resolve, reject) {
          _fsExtra["default"].lstat(entry, function (err, stats) {
            if (err) {
              return reject(err);
            }

            if (!stats.isDirectory()) {
              return resolve({
                title: _path["default"].basename(entry),
                key: _path["default"].basename(entry)
              });
            }

            resolve(new Promise(function (resolve, reject) {
              _fsExtra["default"].readdir(entry, function (err, files) {
                if (err) {
                  return reject(err);
                }

                Promise.all(files.map(function (child) {
                  return walk(_path["default"].join(entry, child));
                })).then(function (children) {
                  resolve({
                    title: _path["default"].basename(entry),
                    key: _path["default"].basename(entry),
                    folder: true,
                    children: children
                  });
                })["catch"](function (err) {
                  reject(err);
                });
              });
            }));
          });
        }));
      });
    });
  };

  return walk(dir);
}