"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = getCurrentuserRole;

var _cookies = _interopRequireDefault(require("cookies"));

var _jwtSimple = _interopRequireDefault(require("jwt-simple"));

var _ = require("../../../");

function getCurrentuserRole(obj) {
  if (typeof obj.express !== 'undefined' && obj.express !== null) {
    var cookies = new _cookies["default"](obj.express.req, obj.express.res, {
      secure: _.config.cookie.secure
    });
    var token = cookies.get('x-access-token');

    if (typeof token !== 'undefined' && token !== null && token !== '') {
      var secret = _.config.users.secret;

      var decoded = _jwtSimple["default"].decode(token, secret);

      var user = _.User.utils.findSync(decoded.iss);

      if (user && user.role) return user.role.workflow;
      return null;
    }
  }

  return '';
}