"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = translate;

var _ = require("../../../");

var _handlebars = _interopRequireDefault(require("handlebars"));

function getVariable(variable, json, options) {
  if (variable.indexOf('{{') > -1) {
    var template = _handlebars["default"].compile(variable);

    var res = template(json);

    if (res === '') {
      template = _handlebars["default"].compile(variable);
      res = template(options.data.root);
    }

    return res;
  } else {
    return variable;
  }
}

function translate(lang, str, json, options) {
  var resLang = getVariable(lang, json, options);
  var resStr = getVariable(str, json, options);
  var trad = _.coreUtils.locales.instance.i18n;

  if (typeof trad[resLang] !== 'undefined' && trad[resLang] !== null && typeof trad[resLang][resStr] !== 'undefined' && trad[resLang][resStr] !== null) {
    return trad[resLang][resStr];
  }

  return resStr;
}