"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.addOrder = addOrder;
exports.autoCreatePostFromTemplate = autoCreatePostFromTemplate;
exports.autoCreatePostFromTemplates = autoCreatePostFromTemplates;
exports.execRequestColumns = execRequestColumns;
exports.getAbeImport = getAbeImport;
exports.getAbePrecontribFromTemplates = getAbePrecontribFromTemplates;
exports.getAbeRequestWhereKeysFromTemplates = getAbeRequestWhereKeysFromTemplates;
exports.getAbeSlugFromTemplates = getAbeSlugFromTemplates;
exports.getAutoCreatePostFromTemplatePathAndName = getAutoCreatePostFromTemplatePathAndName;
exports.getStructureAndTemplates = getStructureAndTemplates;
exports.getTemplate = getTemplate;
exports.getTemplatesAndPartials = getTemplatesAndPartials;
exports.getTemplatesTexts = getTemplatesTexts;
exports.getVariablesInWhere = getVariablesInWhere;
exports.includePartials = includePartials;
exports.recurseWhereVariables = recurseWhereVariables;
exports.setAbePrecontribDefaultValueIfDoesntExist = setAbePrecontribDefaultValueIfDoesntExist;
exports.setAbeSlugDefaultValueIfDoesntExist = setAbeSlugDefaultValueIfDoesntExist;
exports.translate = translate;

var _fs = _interopRequireDefault(require("fs"));

var _bluebird = require("bluebird");

var _path = _interopRequireDefault(require("path"));

var _ = require("../../");

var sourceAttr = _interopRequireWildcard(require("../../cms/editor/handlebars/sourceAttr"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function getTemplatesAndPartials(templatesPath, partialsPath) {
  var allFiles = [];
  var p = new _bluebird.Promise(function (resolve) {
    var extension = '.' + _.config.files.templates.extension;
    return _.coreUtils.file.getFiles(templatesPath, true, extension).then(function (files) {
      allFiles = allFiles.concat(files);
      return _.coreUtils.file.getFiles(partialsPath, true, extension).then(function (files) {
        allFiles = allFiles.concat(files);
        return resolve(allFiles);
      });
    })["catch"](function (e) {
      console.log('Error: template.getTemplatesAndPartials', e.stack);
    });
  });
  return p;
}

function addOrder(text) {
  var regAbe = /{{abe[\S\s].*?key=['|"]([\S\s].*?['|"| ]}})/g;
  var matches = text.match(regAbe);

  if (typeof matches !== 'undefined' && matches !== null) {
    var orderTab = [];
    var arrayKey = [];
    var max = 0;
    var negIndex = -1; // We create an array of keys/order and put -1 for keys without order

    Array.prototype.forEach.call(matches, function (match) {
      if (typeof match !== 'undefined' && match !== null) {
        var orderAttr = _.cmsData.regex.getAttr(match, 'order');

        var keyAttr = _.cmsData.regex.getAttr(match, 'key');

        if (typeof orderAttr === 'undefined' || orderAttr === null || orderAttr === '') {
          orderTab.push({
            key: keyAttr,
            order: negIndex
          });
          negIndex = negIndex - 1;
        } else {
          max = Math.max(parseInt(orderAttr), max);
          orderTab.push({
            key: keyAttr,
            order: orderAttr
          });
        }
      }
    }); // We sort the array

    orderTab.sort(_.coreUtils.sort.predicatBy('order', -1)); // And increment the not ordered ones beginning with the last order found + 1

    Array.prototype.forEach.call(orderTab, function (obj) {
      if (obj.order < 0) {
        max = max + 1;
        arrayKey[obj.key] = max;
      } else {
        arrayKey[obj.key] = parseInt(obj.order);
      }
    }); // Then we put order attribute to each abe tag not ordered

    Array.prototype.forEach.call(matches, function (match) {
      if (typeof match !== 'undefined' && match !== null) {
        var orderAttr = _.cmsData.regex.getAttr(match, 'order');

        var keyAttr = _.cmsData.regex.getAttr(match, 'key');

        if (typeof orderAttr === 'undefined' || orderAttr === null || orderAttr === '') {
          var matchOrder = match.replace(/\}\}$/, " order='".concat(arrayKey[keyAttr], "'}}"));
          text = text.replace(match, matchOrder);
        }
      }
    });
  }

  return text;
}

function getAbeImport(text) {
  var partials = [];
  var listReg = /({{abe.*type=[\'|\"]import.*}})/g;
  var match;

  while (match = listReg.exec(text)) {
    partials.push(match[0]);
  }

  return partials;
}
/**
 * it will include recursively each encountered type=import
 * and proceed to a foreach when the file={{some[]}} is an array of values
 * @param  {[type]} text [description]
 * @param  {[type]} json [description]
 * @return {[type]}      [description]
 */


function includePartials(text, json) {
  var abeImports = _.cmsTemplates.template.getAbeImport(text);

  var duplicateImports = duplicateImports || [];
  Array.prototype.forEach.call(abeImports, function (abeImport) {
    var obj = _.cmsData.attributes.getAll(abeImport, {});

    var file = obj.file;
    var partial = '';

    if (file.charAt(0) == '/') {
      file = _path["default"].join(_.config.root, file);
    } else {
      file = _path["default"].join(_.Manager.instance.pathPartials, file);
    }

    file = _.cmsData.attributes.getValueFromAttribute(file, json);

    if (Object.prototype.toString.call(file) === '[object Array]') {
      Array.prototype.forEach.call(file, function (f) {
        if (_.coreUtils.file.exist(f)) {
          if (duplicateImports[f] != null) {
            var tmpFile = _fs["default"].readFileSync(f, 'utf8');

            var regAbe = /{{abe .*key=[\'|\"](.*?)[\'|\"].*}}/g;
            var matches = tmpFile.match(regAbe);
            var match;

            while ((match = regAbe.exec(tmpFile)) !== null) {
              if (match[1] != null) {
                tmpFile = tmpFile.replace(match[0], match[0].replace(match[1], match[1] + '_' + duplicateImports[f]));
                tmpFile = tmpFile.replace(new RegExp("{{".concat(match[1]), 'g'), '{{' + match[1] + '_' + duplicateImports[f]);
              }
            }

            duplicateImports[f] += 1;
            partial += _.cmsTemplates.template.includePartials(tmpFile, json);
          } else {
            duplicateImports[f] = 1;
            partial += _.cmsTemplates.template.includePartials(_fs["default"].readFileSync(f, 'utf8'), json);
          }
        }
      });
    } else {
      if (_.coreUtils.file.exist(file)) {
        if (duplicateImports[file] != null) {
          var tmpFile = _fs["default"].readFileSync(file, 'utf8');

          var regAbe = /{{abe .*key=[\'|\"](.*?)[\'|\"].*}}/g;
          var match;

          while ((match = regAbe.exec(tmpFile)) !== null) {
            if (match[1] != null) {
              tmpFile = tmpFile.replace(match[0], match[0].replace(match[1], match[1] + '_' + duplicateImports[file]));
              tmpFile = tmpFile.replace(new RegExp("{{".concat(match[1]), 'g'), '{{' + match[1] + '_' + duplicateImports[file]);
            }
          }

          duplicateImports[file] += 1;
          partial = _.cmsTemplates.template.includePartials(tmpFile, json);
        } else {
          duplicateImports[file] = 1;
          partial = _.cmsTemplates.template.includePartials(_fs["default"].readFileSync(file, 'utf8'), json);
        }
      }
    }

    text = text.replace(_.cmsData.regex.escapeTextToRegex(abeImport), partial);
  });
  return text;
}

function translate(text) {
  var importReg = /({{abe.*type=[\'|\"]translate.*}})/g;
  var matches = text.match(importReg);

  if (typeof matches !== 'undefined' && matches !== null) {
    Array.prototype.forEach.call(matches, function (match) {
      var splitedMatches = match.split('{{abe ');
      Array.prototype.forEach.call(splitedMatches, function (splitedMatch) {
        var currentMatch = "{{abe ".concat(splitedMatch);

        if (/({{abe.*type=[\'|\"]translate.*}})/.test(currentMatch)) {
          var locale = _.cmsData.regex.getAttr(currentMatch, 'locale');

          var source = _.cmsData.regex.getAttr(currentMatch, 'source');

          var replace = "{{{i18nAbe \"".concat(locale, "\" \"").concat(source, "\" this}}}");
          text = text.replace(_.cmsData.regex.escapeTextToRegex(currentMatch, 'g'), replace);
        }
      });
    });
  }

  return text;
}

function getTemplate(file) {
  var json = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var text = ''; // HOOKS beforeGetTemplate

  file = _.abeExtend.hooks.instance.trigger('beforeGetTemplate', file);
  file = file.replace(_.Manager.instance.pathTemplates, '');
  file = file.replace(_.config.root, '');

  if (file.indexOf('.') > -1) {
    file = file.replace(/\..+$/, '');
  }

  file = _path["default"].join(_.Manager.instance.pathTemplates, file + '.' + _.config.files.templates.extension);

  if (_.coreUtils.file.exist(file)) {
    text = _fs["default"].readFileSync(file, 'utf8');
    text = _.cmsTemplates.template.includePartials(text, json);
    text = _.cmsTemplates.template.translate(text);
    text = _.cmsTemplates.template.addOrder(text);
  } else {
    text = "[ ERROR ] template ".concat(file, " doesn't exist anymore");
  } // HOOKS afterGetTemplate


  text = _.abeExtend.hooks.instance.trigger('afterGetTemplate', text);
  return text;
}

function getVariablesInWhere(where) {
  var ar = [];

  if (where.left.column.indexOf('{{') > -1) {
    ar.push(where.left.column.replace(/\{\{(.*?)\}\}/, '$1'));
  } else {
    ar.push(where.left.column);
  }

  if (where.right.value) {
    if (typeof where.right.value === 'string') {
      if (where.right.value && where.right.value.indexOf('{{') > -1) {
        ar.push(where.right.value.replace(/\{\{(.*?)\}\}/, '$1'));
      }
    } else {
      where.right.value.forEach(function (value) {
        if (value.column.indexOf('{{') > -1) {
          ar.push(value.column.replace(/\{\{(.*?)\}\}/, '$1'));
        }
      });
    }
  }

  if (where.right.column && where.right.column.indexOf('{{') > -1) {
    ar.push(where.right.column.replace(/\{\{(.*?)\}\}/, '$1'));
  }

  return ar;
}
/**
 * Get columns and where.left ids of a select statement
 *
 * select title, image from ../ where template=""
 *
 * return [title, image, template]
 *
 * @param  {Array} templatesList ["article.html", "other.html"]
 * @return {Promise}
 */


function recurseWhereVariables(where) {
  var ar = [];
  var arLeft;
  var arRight;

  switch (where.operator) {
    case 'AND':
      arLeft = _.cmsTemplates.template.recurseWhereVariables(where.left);
      arRight = _.cmsTemplates.template.recurseWhereVariables(where.right);
      return arLeft.concat(arRight);
      break;

    case 'OR':
      arLeft = _.cmsTemplates.template.recurseWhereVariables(where.left);
      arRight = _.cmsTemplates.template.recurseWhereVariables(where.right);
      return arLeft.concat(arRight);
      break;

    default:
      ar = getVariablesInWhere(where);
      break;
  }

  return ar;
}

function getTemplatesTexts(templatesList, json) {
  var templates = [];
  var p = new _bluebird.Promise(function (resolve) {
    Array.prototype.forEach.call(templatesList, function (file) {
      var template = _fs["default"].readFileSync(file, 'utf8');

      template = _.cmsTemplates.template.includePartials(template, json);
      var name = file.replace(_path["default"].join(_.Manager.instance.pathTemplates, _path["default"].sep), '').replace(".".concat(_.config.files.templates.extension), '');
      templates.push({
        name: name,
        path: file,
        template: template
      });
    });
    resolve(templates);
  });
  return p;
}

function execRequestColumns(tpl) {
  var ar = [];

  var matches = _.cmsData.regex.getAbeTypeDataList(tpl);

  Array.prototype.forEach.call(matches, function (match) {
    var obj = _.cmsData.attributes.getAll(match, {});

    var type = _.cmsData.sql.getSourceType(obj.sourceString);

    switch (type) {
      case 'request':
        var request = _.cmsData.sql.handleSqlRequest(obj.sourceString, {});

        if (typeof request.columns !== 'undefined' && request.columns !== null) {
          Array.prototype.forEach.call(request.columns, function (column) {
            ar.push(column);
          });
        }

        if (typeof request.where !== 'undefined' && request.where !== null) {
          ar = ar.concat(_.cmsTemplates.template.recurseWhereVariables(request.where));
        }

    }
  });
  return ar;
}

function getAbeRequestWhereKeysFromTemplates(templatesList) {
  var whereKeys = [];
  var p = new _bluebird.Promise(function (resolve) {
    Array.prototype.forEach.call(templatesList, function (file) {
      whereKeys = whereKeys.concat(_.cmsTemplates.template.execRequestColumns(file.template));
    });
    whereKeys = whereKeys.filter(function (item, pos) {
      item = item.split('.')[0].split('[')[0];
      return whereKeys.indexOf(item) == pos;
    });
    resolve(whereKeys);
  });
  return p;
}

function setAbeSlugDefaultValueIfDoesntExist(templateText) {
  var matches = _.cmsData.regex.getTagAbeWithType(templateText, 'slug');

  if (matches == null || matches[0] == null) {
    templateText = "{{abe type=\"slug\" source=\"{{name}}\"}}\n".concat(templateText);
  }

  return templateText;
}

function getAbeSlugFromTemplates(templatesList) {
  var slugs = {};
  Array.prototype.forEach.call(templatesList, function (file) {
    var templateText = _.cmsTemplates.template.setAbeSlugDefaultValueIfDoesntExist(file.template);

    var matchesSlug = _.cmsData.regex.getTagAbeWithType(templateText, 'slug');

    var obj = _.cmsData.attributes.getAll(matchesSlug[0], {});

    slugs[file.name] = obj.sourceString;
  });
  return slugs;
}
/**
 * if there is no abe tab='slug' in the template, add a default abe tag
 * @param {[type]} templateText [description]
 */


function setAbePrecontribDefaultValueIfDoesntExist(templateText) {
  var matches = _.cmsData.regex.getTagAbeWithTab(templateText, 'slug');

  if (matches == null || matches[0] == null) {
    templateText = "{{abe type='text' key='name' desc='Name' required=\"true\" tab=\"slug\" visible=\"false\"}}\n".concat(templateText);
  }

  return templateText;
}
/**
 * Lists all templates, in each template:
 * if no tab='slug' replaces the template with default tag {{abe type='text' key='name'...}}
 * then removes all abe tags (but the tab='slug' ones)
 * then adds 'precontribTemplate' with the template name as an attribute to tab='slug' tags
 * @param  {Array} templatesList [description]
 * @return {Array}              [description]
 */


function getAbePrecontribFromTemplates(templatesList) {
  var precontributionTemplate = [];
  Array.prototype.forEach.call(templatesList, function (file) {
    var templateText = _.cmsTemplates.template.setAbePrecontribDefaultValueIfDoesntExist(file.template);

    templateText = templateText.replace(/(?![\s\S]*?tab=['|"]slug)(\{\{abe([\s\S]*?)\}\})/gm, '');
    templateText = templateText.replace(/(\{\{abe.+)(\}\})/g, "$1 precontribTemplate=\"".concat(file.name, "\"$2"));
    precontributionTemplate.push(templateText);
  });
  return precontributionTemplate;
}

function getStructureAndTemplates() {
  var extension = '.' + _.config.files.templates.extension;
  var result = {
    structure: [],
    templates: []
  };
  result.structure = _.coreUtils.file.getFoldersSync(_.Manager.instance.pathStructure, true);

  var templatePaths = _.coreUtils.file.getFilesSync(_.Manager.instance.pathTemplates, true, extension);

  Array.prototype.forEach.call(templatePaths, function (templatePath) {
    var additionalPath = _path["default"].dirname(templatePath).replace(_.Manager.instance.pathTemplates, '');

    if (additionalPath !== '') additionalPath = additionalPath.substring(1);

    var name = _path["default"].join(additionalPath, _path["default"].basename(templatePath, extension));

    var template = {
      path: templatePath,
      name: name
    };
    result.templates.push(template);
  });
  return result;
}

function getAutoCreatePostFromTemplatePathAndName(templateTag) {
  var source = _.cmsData.regex.getAttr(templateTag, 'source');

  var name = '';
  var pathName = '';

  if (source != null) {
    source = source.split('/');
    name = source.pop();
    pathName = source.join('/');
    pathName = pathName.trim() == '' ? '/' : pathName;
  }

  return {
    pathName: pathName,
    name: name
  };
}

function autoCreatePostFromTemplate(data, templatePath) {
  var tplInfos = getAutoCreatePostFromTemplatePathAndName(_.cmsData.regex.getTagAbeWithType(data, 'slug'));
  var tplName = templatePath.split('/');
  tplName = tplName[tplName.length - 1];

  _.coreUtils.file.getFiles(_.Manager.instance.pathData, false).then(function (items) {
    var found = false;

    for (var key in items) {
      var file = _.cmsData.fileAttr["delete"](items[key]);

      if (file === _path["default"].join(_.Manager.instance.pathData, tplInfos.name + '.json')) {
        found = true;
        break;
      }
    }

    if (!found) {
      console.log('tplInfos.pathName', tplInfos.pathName, 'tplInfos.name', tplInfos.name, 'path', _path["default"].join(tplInfos.pathName, tplInfos.name));

      _.cmsOperations.create(tplName, _path["default"].join(tplInfos.pathName, tplInfos.name), {
        body: {}
      });
    }
  });
}

function autoCreatePostFromTemplates(templatePaths) {
  var autoCreatePostFromTemplates = [];
  var index = 0;
  var p = new _bluebird.Promise(function (resolve) {
    Array.prototype.forEach.call(templatePaths, function (templatePath) {
      _fs["default"].readFile(templatePath.path, 'utf8', function read(err, data) {
        var isEditable = true;
        if (err) console.log("Error getStructureAndTemplates() : ", err);

        var templateTag = _.cmsData.regex.getTagAbeWithType(data, 'template');

        if (templateTag.length > 0) {
          var templateTagAttrs = _.cmsData.attributes.getAll(templateTag[0]);

          if (templateTagAttrs['auto-create'] != null && JSON.parse(templateTagAttrs['auto-create'].toLowerCase()) === true) {
            autoCreatePostFromTemplates.push({
              data: data,
              templatePath: templatePath.path
            });
          }

          if (templateTagAttrs.editable != null && templateTagAttrs.editable === false) isEditable = false;
        }

        if (++index === templatePaths.length) {
          Array.prototype.forEach.call(autoCreatePostFromTemplates, function (template) {
            _.cmsTemplates.template.autoCreatePostFromTemplate(template.data, template.templatePath);
          });
          resolve(autoCreatePostFromTemplates);
        }
      });
    });
  });
  return p;
}