"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _fs = _interopRequireDefault(require("fs"));

var _events = _interopRequireDefault(require("events"));

var _path = _interopRequireDefault(require("path"));

var _watch = _interopRequireDefault(require("watch"));

var _express = _interopRequireDefault(require("express"));

var _bodyParser = _interopRequireDefault(require("body-parser"));

var _tinyLr = _interopRequireDefault(require("tiny-lr"));

var _cliColor = _interopRequireDefault(require("cli-color"));

var _ = require("../../");

//import Handlebars from 'handlebars'
var singleton = Symbol();
var singletonEnforcer = Symbol();

var Manager = /*#__PURE__*/function () {
  function Manager(enforcer) {
    (0, _classCallCheck2["default"])(this, Manager);
    if (enforcer != singletonEnforcer) throw 'Cannot construct Json singleton';
  }

  (0, _createClass2["default"])(Manager, [{
    key: "init",
    value: function () {
      var _init = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee() {
        return _regenerator["default"].wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                this._processesRunning = {};
                this.events = {}; // Compatibility for abe version < 3.2.
                // It's possible to reference html from any directory

                if (process.env.ABE_TEMPLATES_PATH) {
                  this.pathTemplates = _path["default"].join(_.config.root, process.env.ABE_TEMPLATES_PATH);
                  this.pathPartials = _path["default"].join(this.pathTemplates, 'partials');
                } else if (_.config.themes != null && _.coreUtils.file.exist(_path["default"].join(_.config.root, _.config.themes.path, _.config.themes.name, _.config.themes.templates.path))) {
                  this.pathTemplates = _path["default"].join(_.config.root, _.config.themes.path, _.config.themes.name, _.config.themes.templates.path);
                  this.pathPartials = _path["default"].join(_.config.root, _.config.themes.path, _.config.themes.name, _.config.themes.partials.path);
                } else {
                  // did the users of the versions < 3.2 overriden the default templates path or partials path ?
                  if (_.config.templates != null && _.config.templates.url != null) {
                    this.pathTemplates = _path["default"].join(_.config.root, _.config.templates.url);
                  } else {
                    this.pathTemplates = _path["default"].join(_.config.root, 'templates');
                  }

                  if (_.config.partials != null) {
                    this.pathPartials = _path["default"].join(_.config.root, _.config.partials);
                  } else {
                    this.pathPartials = _path["default"].join(_.config.root, 'partials');
                  }
                }

                this.pathAssets = this.pathTemplates;

                if (process.env.ABE_ASSETS_PATH) {
                  this.pathAssets = _path["default"].join(_.config.root, process.env.ABE_ASSETS_PATH);
                }

                this.pathPublish = _path["default"].join(_.config.root, _.config.publish.url);

                if (process.env.ABE_DESTINATION_PATH) {
                  this.pathPublish = _path["default"].join(_.config.root, process.env.ABE_DESTINATION_PATH);
                } // config.data.url was the config prior to v3.7.0


                if (process.env.ABE_JSON_PATH) {
                  this.pathData = _path["default"].join(_.config.root, process.env.ABE_JSON_PATH);
                } else if (_.config.data.url != null) {
                  this.pathData = _path["default"].join(_.config.root, _.config.data.url);
                } else if (_.coreUtils.file.exist(_path["default"].join(_.config.root, _.config.data.path))) {
                  this.pathData = _path["default"].join(_.config.root, _.config.data.path);
                } else {
                  this.pathData = _path["default"].join(_.config.root, 'data');
                }

                this.pathTemplates = this.pathTemplates.replace(/\/$/, '');
                this.pathPartials = this.pathPartials.replace(/\/$/, '');
                this.pathAssets = this.pathAssets.replace(/\/$/, '');
                this.pathPublish = this.pathPublish.replace(/\/$/, '');
                this.pathData = this.pathData.replace(/\/$/, '');
                this.pathScripts = _path["default"].join(_.config.root, _.config.scripts.path);
                this.pathStructure = _path["default"].join(_.config.root, _.config.structure.url);
                this.pathReference = _path["default"].join(_.config.root, _.config.reference.url);
                this.pathLocales = _path["default"].join(_.config.root, 'locales');
                this.connections = [];
                this.activities = _.User.utils.getActivity();

                this._watcherActivity();

                this.updateStructureAndTemplates();

                _.cmsTemplates.template.autoCreatePostFromTemplates(this._structureAndTemplates.templates);

                _context.next = 24;
                return this.getKeysFromSelect();

              case 24:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function init() {
        return _init.apply(this, arguments);
      }

      return init;
    }()
  }, {
    key: "initDev",
    value: function initDev() {
      var _this = this;

      console.log("You are in ".concat(process.env.NODE_ENV, " mode"));
      console.log('which means every change in your themes (templates, partials and assets), reference and structure folders will dynamically update your site');
      console.log("In production, this mode shouldn't be used.");

      this._watchersStart();

      var lport = process.env.LIVERELOAD_PORT || 35729;
      this.lserver = (0, _express["default"])(); // Launching a Livereload server

      this.lserver.use(_bodyParser["default"].json()).use(_bodyParser["default"].urlencoded({
        extended: true
      })).use(_tinyLr["default"].middleware({
        app: this.lserver
      })).listen(lport, function () {
        console.log('Livereload listening on %d', lport);
      }).on('error', function (err) {
        if (err.code == 'EADDRINUSE') {
          console.error(_cliColor["default"].red("can't start the Abe's watch server\n"), "This watch server has tried to listen on the port ".concat(lport, " but this server is already in use by another process..."));
        } else {
          console.error(err);
        }
      });
      process.on('SIGINT', function () {
        try {
          _this.lserver.close(function () {
            console.log('SIGINT:Livereload server has been gracefully terminated');
            process.exit(0);
          });
        } catch (error) {}
      });
      process.on('SIGTERM', function () {
        try {
          _this.lserver.close(function () {
            console.log('SIGTERM:Livereload server has been gracefully terminated');
            process.exit(0);
          });
        } catch (error) {}
      }); // sync assets from templates to /site

      _.cmsTemplates.assets.copy();
    }
  }, {
    key: "_watcherActivity",
    value: function _watcherActivity() {
      this.events.activity = new _events["default"].EventEmitter(0);
      this.events.activity.on('activity', function (data) {
        data.time = new Date().toISOString();

        if (data.user && data.user.username) {
          data.user = data.user.username;
        } else {
          data.user = 'admin';
        }

        this.addActivity(data);
        this.events.activity.emit('activity-stream', data);
      }.bind(this));
    }
  }, {
    key: "_watchersStart",
    value: function _watchersStart() {
      var _this2 = this;

      this.events.template = new _events["default"].EventEmitter(0);
      this.events.structure = new _events["default"].EventEmitter(0);
      this.events.reference = new _events["default"].EventEmitter(0);
      this.events.scripts = new _events["default"].EventEmitter(0);
      this.events.locales = new _events["default"].EventEmitter(0); // watch template folder

      try {
        _fs["default"].accessSync(this.pathTemplates, _fs["default"].F_OK);

        this._watchTemplateFolder = _watch["default"].createMonitor(this.pathTemplates, function (monitor) {
          monitor.on('created', function (f, stat) {
            if (f.indexOf(".".concat(_.config.files.templates.extension)) < 0) {
              _.cmsTemplates.assets.copy();

              _tinyLr["default"].changed(f);

              console.log('Assets have been synchronized after this creation: ' + f);
            } else {
              _this2.getKeysFromSelect();

              _this2.updateStructureAndTemplates();

              if (typeof _this2.lserver != 'undefined') {
                _tinyLr["default"].changed(f);
              }

              _this2.events.template.emit('update');
            }
          });
          monitor.on('changed', function (f, curr, prev) {
            if (f.indexOf(".".concat(_.config.files.templates.extension)) < 0) {
              _.cmsTemplates.assets.copy();

              if (typeof _this2.lserver != 'undefined') {
                _tinyLr["default"].changed(f);
              }

              console.log('Assets have been synchronized after this modification: ' + f);
            } else {
              _this2.getKeysFromSelect();

              _this2.updateStructureAndTemplates();

              if (typeof _this2.lserver != 'undefined') {
                _tinyLr["default"].changed(f);
              }

              _this2.events.template.emit('update');
            }
          });
          monitor.on('removed', function (f, stat) {
            if (f.indexOf(".".concat(_.config.files.templates.extension)) < 0) {
              _.cmsTemplates.assets.copy();

              if (typeof _this2.lserver != 'undefined') {
                _tinyLr["default"].changed(f);
              }

              console.log('Assets have been synchronized after this deletion: ' + f);
            } else {
              _this2.getKeysFromSelect();

              _this2.updateStructureAndTemplates();

              if (typeof _this2.lserver != 'undefined') {
                _tinyLr["default"].changed(f);
              }

              _this2.events.template.emit('update');
            }
          });
        });
      } catch (e) {
        console.log('the directory ' + this.pathTemplates + ' does not exist');
      } // watch partial folder


      try {
        _fs["default"].accessSync(this.pathPartials, _fs["default"].F_OK);

        this._watchPartialsFolder = _watch["default"].createMonitor(this.pathPartials, function (monitor) {
          monitor.on('created', function (f) {
            _this2.getKeysFromSelect();

            _this2.updateStructureAndTemplates();

            if (typeof _this2.lserver != 'undefined') {
              _tinyLr["default"].changed(f);
            }

            _this2.events.template.emit('update');
          });
          monitor.on('changed', function (f) {
            _this2.getKeysFromSelect();

            _this2.updateStructureAndTemplates();

            if (typeof _this2.lserver != 'undefined') {
              _tinyLr["default"].changed(f);
            }

            _this2.events.template.emit('update');
          });
          monitor.on('removed', function (f) {
            _this2.getKeysFromSelect();

            _this2.updateStructureAndTemplates();

            if (typeof _this2.lserver != 'undefined') {
              _tinyLr["default"].changed(f);
            }

            _this2.events.template.emit('update');
          });
        });
      } catch (e) {
        console.log('the directory ' + this.pathPartials + ' does not exist');
      } // watch structure folder


      try {
        _fs["default"].accessSync(this.pathStructure, _fs["default"].F_OK);

        this._watchStructure = _watch["default"].createMonitor(this.pathStructure, function (monitor) {
          monitor.on('created', function () {
            _this2.updateStructureAndTemplates();

            _this2.events.structure.emit('update');
          });
          monitor.on('changed', function () {
            _this2.updateStructureAndTemplates();

            _this2.events.structure.emit('update');
          });
          monitor.on('removed', function () {
            _this2.updateStructureAndTemplates();

            _this2.events.structure.emit('update');
          });
        });
      } catch (e) {
        console.log('the directory ' + this.pathStructure + ' does not exist');
      } // watch reference folder


      try {
        _fs["default"].accessSync(this.pathReference, _fs["default"].F_OK);

        this._watchReferenceFolder = _watch["default"].createMonitor(this.pathReference, function (monitor) {
          monitor.on('created', function (f) {
            _this2.updateReferences(f);

            if (typeof _this2.lserver != 'undefined') {
              _tinyLr["default"].changed(f);
            }

            _this2.events.reference.emit('update');
          });
          monitor.on('changed', function (f) {
            _this2.updateReferences(f);

            if (typeof _this2.lserver != 'undefined') {
              _tinyLr["default"].changed(f);
            }

            _this2.events.reference.emit('update');
          });
          monitor.on('removed', function (f) {
            _this2.updateReferences();

            if (typeof _this2.lserver != 'undefined') {
              _tinyLr["default"].changed(f);
            }

            _this2.events.reference.emit('update');
          });
        });
      } catch (e) {
        console.log('the directory ' + this.pathReference + ' does not exist');
      } // watch locales folder


      try {
        _fs["default"].accessSync(this.pathLocales, _fs["default"].F_OK);

        this._watchLocalesFolder = _watch["default"].createMonitor(this.pathLocales, function (monitor) {
          monitor.on('created', function (f) {
            _.coreUtils.locales.instance.reloadLocales();

            if (typeof _this2.lserver != 'undefined') {
              _tinyLr["default"].changed(f);
            }

            _this2.events.locales.emit('update');
          });
          monitor.on('changed', function (f) {
            _.coreUtils.locales.instance.reloadLocales();

            if (typeof _this2.lserver != 'undefined') {
              _tinyLr["default"].changed(f);
            }

            _this2.events.locales.emit('update');
          });
          monitor.on('removed', function (f) {
            _.coreUtils.locales.instance.reloadLocales();

            if (typeof _this2.lserver != 'undefined') {
              _tinyLr["default"].changed(f);
            }

            _this2.events.locales.emit('update');
          });
        });
      } catch (e) {
        console.log('the directory ' + this.pathLocales + ' does not exist');
      } // watch scripts folder


      try {
        _fs["default"].accessSync(this.pathScripts, _fs["default"].F_OK);

        this._watchScripts = _watch["default"].createMonitor(this.pathScripts, function (monitor) {
          monitor.on('created', function () {
            _.abeExtend.plugins.instance.updateScripts();

            _this2.events.scripts.emit('update');
          });
          monitor.on('changed', function () {
            _.abeExtend.plugins.instance.updateScripts();

            _this2.events.scripts.emit('update');
          });
          monitor.on('removed', function () {
            _.abeExtend.plugins.instance.updateScripts();

            _this2.events.scripts.emit('update');
          });
        });
      } catch (e) {
        console.log('the directory ' + this.pathScripts + ' does not exist');
      }
    }
  }, {
    key: "getKeysFromSelect",
    value: function getKeysFromSelect() {
      var _this3 = this;

      this._whereKeys = [];
      var p = new Promise(function (resolve) {
        _.cmsTemplates.template.getTemplatesAndPartials(_this3.pathTemplates, _this3.pathPartials).then(function (templatesList) {
          return _.cmsTemplates.template.getTemplatesTexts(templatesList).then(function (templatesText) {
            return _.cmsTemplates.template.getAbeRequestWhereKeysFromTemplates(templatesText).then( /*#__PURE__*/function () {
              var _ref = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2(whereKeys) {
                return _regenerator["default"].wrap(function _callee2$(_context2) {
                  while (1) {
                    switch (_context2.prev = _context2.next) {
                      case 0:
                        _this3._whereKeys = whereKeys;
                        _this3._slugs = _.cmsTemplates.template.getAbeSlugFromTemplates(templatesText);
                        _this3._precontribution = _.cmsTemplates.template.getAbePrecontribFromTemplates(templatesText);
                        _context2.next = 5;
                        return _this3.updateList();

                      case 5:
                        resolve();

                      case 6:
                      case "end":
                        return _context2.stop();
                    }
                  }
                }, _callee2);
              }));

              return function (_x) {
                return _ref.apply(this, arguments);
              };
            }(), function (e) {
              console.log('Reject: Manager.findRequestColumns', e.stack);
            })["catch"](function (e) {
              console.log('Error: Manager.findRequestColumns', e.stack);
            });
          }, function (e) {
            console.log('Reject: Manager.getTemplatesTexts', e.stack);
          })["catch"](function (e) {
            console.log('Error: Manager.getTemplatesTexts', e.stack);
          });
        }, function (e) {
          console.log('Manager.getKeysFromSelect', e.stack);
        })["catch"](function (e) {
          console.log('Manager.getKeysFromSelect', e.stack);
        });
      });
      return p;
    }
  }, {
    key: "getStructureAndTemplates",
    value: function getStructureAndTemplates() {
      return this._structureAndTemplates;
    }
  }, {
    key: "updateStructureAndTemplates",
    value: function updateStructureAndTemplates() {
      this._structureAndTemplates = _.cmsTemplates.template.getStructureAndTemplates();
    }
  }, {
    key: "getThumbsList",
    value: function getThumbsList() {
      if (typeof this._thumbs === 'undefined' || this._thumbs === null) this._thumbs = _.cmsMedia.image.getThumbsList();
      return this._thumbs;
    }
  }, {
    key: "addThumbsToList",
    value: function addThumbsToList(thumb) {
      if (this._thumbs) this._thumbs.push(thumb);
    }
  }, {
    key: "getReferences",
    value: function getReferences() {
      if (typeof this._references === 'undefined' || this._references === null) this.updateReferences();
      return this._references;
    }
  }, {
    key: "getPrecontribution",
    value: function getPrecontribution() {
      return this._precontribution;
    }
  }, {
    key: "getSlugs",
    value: function getSlugs() {
      return this._slugs;
    }
  }, {
    key: "updateReferences",
    value: function updateReferences(referenceName) {
      var references = _.cmsReference.reference.getFiles();

      if (referenceName && references[referenceName]) this._references[referenceName] = references[referenceName];else this._references = references;
      return this;
    }
  }, {
    key: "getList",
    value: function getList() {
      return this._list;
    }
  }, {
    key: "getListWithStatusOnFolder",
    value: function getListWithStatusOnFolder(status) {
      var subPath = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';
      var list = [];
      var subPathFull = "".concat(subPath.replace(/^\/|\/$/g, ''), "/");
      Array.prototype.forEach.call(this._list, function (file) {
        if (typeof file[status] !== 'undefined' && file[status] !== null && (subPath === '' || file.path.startsWith(subPathFull))) {
          list.push(file);
        }
      });
      return list;
    }
  }, {
    key: "setList",
    value: function setList(list) {
      this._list = list;
      return this;
    }
    /**
     * return true if postUrl is found in the Manager list
     * @param {String} postUrl The url path of the file
     */

  }, {
    key: "postExist",
    value: function postExist(postUrl) {
      var docPath = _.cmsData.utils.getDocRelativePathFromPostUrl(postUrl);

      var found = _.coreUtils.array.find(this._list, 'path', docPath);

      if (found.length > 0) {
        return true;
      }

      return false;
    }
    /**
     * When a post is modified or created, this method is called so that the manager updates the list with the updated/new item
     * @param {String} revisionPath The full path to the post
     */

  }, {
    key: "updatePostInList",
    value: function () {
      var _updatePostInList = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee3(revisionPath) {
        var docPath, found, json, index, merged, revision, sortedResult, rev, _sortedResult;

        return _regenerator["default"].wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                if (!(typeof this._list === 'undefined' || this._list === null)) {
                  _context3.next = 3;
                  break;
                }

                _context3.next = 3;
                return this.updateList();

              case 3:
                docPath = _.cmsData.utils.getDocRelativePath(revisionPath);
                found = _.coreUtils.array.find(this._list, 'path', docPath);
                _context3.next = 7;
                return _.cmsData.revision.getDoc(revisionPath);

              case 7:
                json = _context3.sent;
                merged = {};
                revision = _.cmsData.revision.getFileObject(revisionPath, json);
                revision = _.cmsData.file.getAbeMeta(revision, json);
                Array.prototype.forEach.call(this._whereKeys, function (key) {
                  var keyFirst = key.split('.')[0];
                  revision[keyFirst] = json[keyFirst];
                });

                if (found.length > 0) {
                  index = found[0];
                  merged[docPath] = this._list[index]; // If I publish, I remove the previous published versions

                  if (revision.abe_meta.status === 'publish') {
                    Array.prototype.forEach.call(merged[docPath].revisions, function (revision, revIndex) {
                      if (revision.abe_meta.status === 'publish') {
                        merged[docPath].revisions.splice(revIndex, 1);
                      }
                    });
                  }

                  merged[docPath].revisions.push(JSON.parse(JSON.stringify(revision)));
                  sortedResult = _.cmsData.revision.sortRevisions(merged); // Does the publish version has been removed (in the case of unpublish) ?

                  if (sortedResult[0]['publish'] && !_.cmsData.revision.exist(sortedResult[0]['publish']['path'])) {
                    delete sortedResult[0]['publish'];
                  }

                  this._list[index] = sortedResult[0];
                } else {
                  index = this._list.length;
                  rev = [];
                  rev.push(revision);
                  merged = _.cmsData.revision.mergeRevisions(rev);
                  _sortedResult = _.cmsData.revision.sortRevisions(merged);

                  this._list.push(_sortedResult[0]);
                }

                this._list.sort(_.coreUtils.sort.predicatBy('date', -1));

                this.historize(index);

              case 15:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function updatePostInList(_x2) {
        return _updatePostInList.apply(this, arguments);
      }

      return updatePostInList;
    }()
    /**
     * When data.history is set, we do keep the number of revisions = history in the most recent date order
     * @param  {[type]} index [description]
     * @return {[type]}       [description]
     */

  }, {
    key: "historize",
    value: function historize(index) {
      var _this4 = this;

      if (_.config.data.history && _.config.data.history > 0) {
        var arStatus = [];

        if (this._list[index].revisions.length > _.config.data.history) {
          Array.prototype.forEach.call(this._list[index].revisions, function (revision, revIndex) {
            if (revIndex >= _.config.data.history) {
              if (revision.abe_meta.status === 'publish') {
                if (arStatus.indexOf(revision.abe_meta.status) < 0) {
                  arStatus.push(revision.abe_meta.status);
                } else {
                  _this4._list[index].revisions.splice(revIndex, 1);
                }
              } else {
                _this4._list[index].revisions.splice(revIndex, 1);

                _.cmsOperations.remove.removeRevision(revision.path);
              }
            } else if (arStatus.indexOf(revision.abe_meta.status) < 0) {
              arStatus.push(revision.abe_meta.status);
            }
          });
        }
      }
    }
    /**
     * When a post is deleted, this method is called so that the manager updates the list with the removed item
     * @param {String} postUrl The URL of the post
     */

  }, {
    key: "removePostFromList",
    value: function removePostFromList(postUrl) {
      var docPath = _.cmsData.utils.getDocRelativePathFromPostUrl(postUrl);

      this._list = _.coreUtils.array.removeByAttr(this._list, 'path', docPath);
    }
    /**
     * This method loads all posts into an array with values used in "select" statements from templates
     * + abe_meta data
     * @return {Array} Array of objects representing the posts including their revisions
     */

  }, {
    key: "updateList",
    value: function () {
      var _updateList = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee4() {
        return _regenerator["default"].wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                _context4.next = 2;
                return _.cmsData.revision.getAllWithKeys(this._whereKeys);

              case 2:
                this._list = _context4.sent;

                this._list.sort(_.coreUtils.sort.predicatBy('date', -1));

                console.log('Manager updated');

              case 5:
              case "end":
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function updateList() {
        return _updateList.apply(this, arguments);
      }

      return updateList;
    }()
  }, {
    key: "getPage",
    value: function getPage() {
      var start = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 0;
      var length = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 20;
      var sortField = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 'date';
      var sortDir = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : -1;
      var search = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : '';
      var searchFields = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : ['abe_meta.link', 'abe_meta.template', 'name'];
      var total = this._list.length;
      var totalFiltered = total;

      var list = this._list.slice();

      if (search !== '') {
        var searches = search.split(' ');

        for (var i = 0; i < searches.length; i++) {
          list = _.coreUtils.array.facet(list, searchFields, searches[i]);
        }

        totalFiltered = list.length;
      }

      if (sortField != 'date' || sortDir != -1) {
        list.sort(_.coreUtils.sort.predicatBy(sortField, sortDir));
      }

      list = list.slice(start, start + length);
      return {
        recordsTotal: total,
        recordsFiltered: totalFiltered,
        data: list
      };
    }
  }, {
    key: "addProcess",
    value: function addProcess(name) {
      this._processesRunning[name] = true;
    }
  }, {
    key: "removeProcess",
    value: function removeProcess(name) {
      delete this._processesRunning[name];
    }
  }, {
    key: "isProcessRunning",
    value: function isProcessRunning(name) {
      if (this._processesRunning[name] !== null && this._processesRunning[name] === true) {
        return true;
      } else {
        return false;
      }
    }
  }, {
    key: "getActivities",
    value: function getActivities() {
      return _.User.utils.getActivity();
    }
  }, {
    key: "addActivity",
    value: function addActivity(activity) {
      _.User.utils.addActivity(activity);
    }
  }, {
    key: "getConnections",
    value: function getConnections() {
      return this.connections;
    }
  }, {
    key: "addConnection",
    value: function addConnection(res) {
      this.connections.push(res);
    }
  }, {
    key: "removeConnection",
    value: function removeConnection(res) {
      var i = this.connections.indexOf(res);

      if (i !== -1) {
        this.connections.splice(i, 1);
      }
    }
  }], [{
    key: "instance",
    get: function get() {
      if (!this[singleton]) {
        this[singleton] = new Manager(singletonEnforcer);
      }

      return this[singleton];
    }
  }]);
  return Manager;
}();

var _default = Manager;
exports["default"] = _default;