"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _fsExtra = _interopRequireDefault(require("fs-extra"));

var _path = _interopRequireDefault(require("path"));

var _ = require("../../");

var singleton = Symbol();
var singletonEnforcer = Symbol();

var Locales = /*#__PURE__*/function () {
  function Locales(enforcer) {
    (0, _classCallCheck2["default"])(this, Locales);
    if (enforcer != singletonEnforcer) throw 'Cannot construct Json singleton';
    this.i18n = this._getLocales();
  }

  (0, _createClass2["default"])(Locales, [{
    key: "reloadLocales",
    value: function reloadLocales() {
      this.i18n = this._getLocales();
    }
  }, {
    key: "_getLocales",
    value: function _getLocales() {
      var loc = {};
      var extension = '.json';

      var localesFolder = _path["default"].join(_.config.root, 'locales');

      var files = _.coreUtils.file.getFilesSync(localesFolder, true, extension);

      Array.prototype.forEach.call(files, function (file) {
        var name = _path["default"].basename(file, extension);

        loc[name] = _fsExtra["default"].readJsonSync(file);
      });
      return loc;
    }
  }], [{
    key: "instance",
    get: function get() {
      if (!this[singleton]) {
        this[singleton] = new Locales(singletonEnforcer);
      }

      return this[singleton];
    }
  }]);
  return Locales;
}();

var _default = Locales;
exports["default"] = _default;