"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.clean = clean;

var _slugify = _interopRequireDefault(require("slugify"));

var _path = _interopRequireDefault(require("path"));

var _ = require("../../");

function clean(str) {
  if (typeof str === 'undefined' || str === null) return null;
  str = str.split('/');
  str[str.length - 1] = slugify(decodeURIComponent(str[str.length - 1]));
  return str.join('/');
}

function slugify(str) {
  str = str.replace(/\..+$/, '').toLowerCase();
  str = (0, _slugify["default"])(str, {
    remove: /[$*+~.()'"!\:@§^,;]/g
  });
  str = "".concat(str, ".").concat(_.config.files.templates.extension);
  return str.toLowerCase();
}