"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.checkXss = checkXss;
exports.md5 = md5;
exports.replaceUnwantedChar = replaceUnwantedChar;

var _xss = _interopRequireDefault(require("xss"));

var _crypto = _interopRequireDefault(require("crypto"));

function replaceUnwantedChar(str) {
  var additionnalChar = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
  var chars = {
    '’': '',
    "'": '',
    '"': '',
    Š: 'S',
    š: 's',
    Ž: 'Z',
    ž: 'z',
    À: 'A',
    Á: 'A',
    Â: 'A',
    Ã: 'A',
    Ä: 'A',
    Å: 'A',
    Æ: 'A',
    Ç: 'C',
    È: 'E',
    É: 'E',
    Ê: 'E',
    Ë: 'E',
    Ì: 'I',
    Í: 'I',
    Î: 'I',
    Ï: 'I',
    Ñ: 'N',
    Ò: 'O',
    Ó: 'O',
    Ô: 'O',
    Õ: 'O',
    Ö: 'O',
    Ø: 'O',
    Ù: 'U',
    Ú: 'U',
    Û: 'U',
    Ü: 'U',
    Ý: 'Y',
    Þ: 'B',
    ß: 'Ss',
    à: 'a',
    á: 'a',
    â: 'a',
    ã: 'a',
    ä: 'a',
    å: 'a',
    æ: 'a',
    ç: 'c',
    è: 'e',
    é: 'e',
    ê: 'e',
    ë: 'e',
    œ: 'oe',
    ì: 'i',
    í: 'i',
    î: 'i',
    ï: 'i',
    ð: 'o',
    ñ: 'n',
    ò: 'o',
    ó: 'o',
    ô: 'o',
    õ: 'o',
    ö: 'o',
    ø: 'o',
    ù: 'u',
    ú: 'u',
    û: 'u',
    ý: 'y',
    þ: 'b',
    ÿ: 'y'
  };

  for (var prop in chars) {
    str = str.replace(new RegExp(prop, 'g'), chars[prop]);
  }

  if (additionnalChar != null) for (var prop in additionnalChar) {
    str = str.replace(new RegExp(prop, 'g'), additionnalChar[prop]);
  }
  return str;
}

function checkXss(newUser) {
  var newUserStr = JSON.stringify(newUser);
  var testXSS = (0, _xss["default"])(newUserStr.replace(/[a-zA-Z0-9-]*?=\\[\"\'].*?[\"\']/g, ''), {
    whiteList: [],
    stripIgnoreTag: true // stripIgnoreTagBody: ['script']

  });
  testXSS = testXSS.replace(/&lt;/g, "<").replace(/&gt;/g, ">");

  if (testXSS !== newUserStr) {
    return {
      success: 0,
      message: 'invalid characters'
    };
  }

  return {
    success: 1
  };
}
/**
* MD5 hashes the specified string.
* @param  {String} str A string to hash.
* @return {String}     The hashed string.
*/


function md5(str) {
  str = str.toLowerCase().trim();
  return _crypto["default"].createHash('md5').update(str).digest('hex');
}