"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _child_process = _interopRequireDefault(require("child_process"));

var _fs = _interopRequireDefault(require("fs"));

var _ = require("../");

function prepend(value, array) {
  var newArray = array.slice(0);
  newArray.unshift(value);
  return newArray;
}

var abeProcess = function abeProcess(name) {
  var args = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
  var callback = arguments.length > 2 ? arguments[2] : undefined;
  args = prepend("ABE_WEBSITE=".concat(_.config.root), args);
  args = prepend("ABECMS_PATH=".concat(__dirname, "/../../../dist"), args);

  if (_.Manager.instance.isProcessRunning(name)) {
    return false;
  }

  _.Manager.instance.addProcess(name);

  var proc;
  var file = "".concat(__dirname, "/../../cli/process/").concat(name, ".js");

  try {
    var stats = _fs["default"].statSync(file);

    if (stats.isFile()) {
      proc = _child_process["default"].fork(file, args);
    }
  } catch (err) {
    try {
      file = _.abeExtend.plugins.instance.getProcess(name);
      stats = _fs["default"].statSync(file);

      if (stats.isFile()) {
        proc = _child_process["default"].fork(file, args);
      }
    } catch (err) {
      _.Manager.instance.removeProcess(name);

      console.log("Manager.instance.addProcess : process fork failed on ".concat(__dirname, "/../../cli/process/").concat(name, ".js"));
    }
  }

  if (typeof proc !== 'undefined' && proc !== null) {
    proc.on('message', function (data) {
      var data = JSON.parse(data);
      callback(data);

      if (data.msg == 'exit') {
        _.Manager.instance.removeProcess(name);

        proc.kill();
      }
    });
    return true;
  }

  return false;
};

var _default = abeProcess;
exports["default"] = _default;