"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _path = _interopRequireDefault(require("path"));

var _fsExtra = _interopRequireDefault(require("fs-extra"));

var _initAbeForProcesses = require("./initAbeForProcesses");

// IMPORT LIB
var Page = require('../../cli').Page;

var cmsOperations = require('../../cli').cmsOperations;

var abeExtend = require('../../cli').abeExtend;

var Manager = require('../../cli').Manager;

var cmsData = require('../../cli').cmsData;

var cmsTemplates = require('../../cli').cmsTemplates;

var config = require('../../cli').config;

var templatesTexts = {};

function publishNext(_x, _x2, _x3) {
  return _publishNext.apply(this, arguments);
}

function _publishNext() {
  _publishNext = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2(files, tt, cb) {
    var i,
        pub,
        jsonObject,
        textTmp,
        matches,
        obj,
        page,
        relatedTemplates,
        _args2 = arguments;
    return _regenerator["default"].wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            i = _args2.length > 3 && _args2[3] !== undefined ? _args2[3] : 0;
            pub = files.shift();

            if (!(typeof pub !== 'undefined' && pub !== null)) {
              _context2.next = 28;
              break;
            }

            // process.send is only defined in a child process
            if (typeof process.send === 'function') {
              process.send(JSON.stringify({
                percent: Math.round((i + 1) * 100 / tt * 100) / 100,
                time: (0, _initAbeForProcesses.getTime)()
              }));
            }

            _context2.next = 6;
            return _fsExtra["default"].readJson(pub[_initAbeForProcesses.processConfig.ABE_STATUS].path);

          case 6:
            jsonObject = _context2.sent;
            i++;

            if (typeof templatesTexts[jsonObject.abe_meta.template] === 'undefined' || templatesTexts[jsonObject.abe_meta.template] === null) {
              templatesTexts[jsonObject.abe_meta.template] = cmsTemplates.template.getTemplate(jsonObject.abe_meta.template, jsonObject);
            }

            _context2.next = 11;
            return cmsData.source.updateJsonWithExternalData(templatesTexts[jsonObject.abe_meta.template], jsonObject);

          case 11:
            jsonObject = abeExtend.hooks.instance.trigger('afterupdateJsonWithExternalDataOnSave', jsonObject); // removing each blocks potentially containing abe data type then updating the source
            // ie. You have a reference file in an abe data type source and you update this reference file
            // then it triggers a generate-posts to rebuild the posts and update the content with these
            // new data

            textTmp = templatesTexts[jsonObject.abe_meta.template].replace(cmsData.regex.eachBlockPattern, '');
            matches = cmsData.regex.getAbeTypeDataList(textTmp);
            Array.prototype.forEach.call(matches, function (match) {
              var obj = cmsData.attributes.getAll(match, jsonObject);

              if (!obj.editable) {
                jsonObject[obj.key] = obj.source;
              }
            });
            obj = {
              publishAll: true,
              type: jsonObject.abe_meta.status,
              json: {
                content: jsonObject
              }
            };
            page = new Page(templatesTexts[jsonObject.abe_meta.template], obj.json.content, true);
            cmsOperations.save.saveHtml(_path["default"].join(config.root, _initAbeForProcesses.processConfig.ABE_DESTINATION, jsonObject.abe_meta.link), page.html); // are there additional templates to export?

            if (!obj.json.content.abe_meta.relatedTemplates) {
              _context2.next = 22;
              break;
            }

            relatedTemplates = Object.keys(obj.json.content.abe_meta.relatedTemplates);
            _context2.next = 22;
            return Promise.all(relatedTemplates.map( /*#__PURE__*/function () {
              var _ref = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(key, index) {
                var relatedTemplate, relTemplate, extension, fileName, relPath, _page;

                return _regenerator["default"].wrap(function _callee$(_context) {
                  while (1) {
                    switch (_context.prev = _context.next) {
                      case 0:
                        relatedTemplate = obj.json.content.abe_meta.relatedTemplates[key];

                        if (!(relatedTemplate.template && relatedTemplate.path)) {
                          _context.next = 11;
                          break;
                        }

                        relTemplate = cmsTemplates.template.getTemplate(relatedTemplate.template, obj.json.content);
                        extension = config.files.templates.extension;
                        if (relatedTemplate.extension) extension = relatedTemplate.extension;
                        fileName = _path["default"].basename(obj.json.content.abe_meta.link, '.' + config.files.templates.extension) + '.' + extension;
                        relPath = _path["default"].join(config.root, _initAbeForProcesses.processConfig.ABE_DESTINATION, relatedTemplate.path, fileName);
                        _context.next = 9;
                        return cmsData.source.updateJsonWithExternalData(relTemplate, obj.json.content);

                      case 9:
                        _page = new Page(relTemplate, obj.json.content, true);
                        cmsOperations.save.saveHtml(relPath, _page.html);

                      case 11:
                      case "end":
                        return _context.stop();
                    }
                  }
                }, _callee);
              }));

              return function (_x4, _x5) {
                return _ref.apply(this, arguments);
              };
            }()));

          case 22:
            obj = abeExtend.hooks.instance.trigger('afterSave', obj);
            (0, _initAbeForProcesses.trace)('(' + (0, _initAbeForProcesses.getTime)() + ') ' + i + ' - ' + pub[_initAbeForProcesses.processConfig.ABE_STATUS].path.replace(Manager.instance.pathData, '') + ' (tpl: ' + jsonObject.abe_meta.template + ')');
            _context2.next = 26;
            return publishNext(files, tt, cb, i++);

          case 26:
            _context2.next = 29;
            break;

          case 28:
            cb(i);

          case 29:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));
  return _publishNext.apply(this, arguments);
}

function startProcess() {
  return _startProcess.apply(this, arguments);
}

function _startProcess() {
  _startProcess = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee3() {
    var files;
    return _regenerator["default"].wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            (0, _initAbeForProcesses.log)("start publishing all files in directory ".concat(_initAbeForProcesses.processConfig.ABE_PATH));
            (0, _initAbeForProcesses.log)("searching for file in ".concat(config.root));
            (0, _initAbeForProcesses.log)("searcing status: ".concat(_initAbeForProcesses.processConfig.ABE_STATUS));
            (0, _initAbeForProcesses.log)("save to: ".concat(_path["default"].join(config.root, _initAbeForProcesses.processConfig.ABE_DESTINATION)));
            files = Manager.instance.getListWithStatusOnFolder(_initAbeForProcesses.processConfig.ABE_STATUS, _initAbeForProcesses.processConfig.ABE_PATH);
            (0, _initAbeForProcesses.log)('Found ' + files.length + ' to republish');
            _context3.next = 8;
            return publishNext(files, files.length, function (i) {
              (0, _initAbeForProcesses.log)('total ' + i + ' files');
              (0, _initAbeForProcesses.log)('publish process finished ' + (0, _initAbeForProcesses.getTime)());

              if (typeof process.send === 'function') {
                process.send(JSON.stringify({
                  msg: 'exit'
                }));
              }

              process.exit(0);
            });

          case 8:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3);
  }));
  return _startProcess.apply(this, arguments);
}

(0, _initAbeForProcesses.init)('generate-posts', {
  ABE_STATUS: 'publish',
  ABE_PATH: '',
  ABE_DESTINATION: 'site'
}).then(startProcess, function (msg) {
  if (typeof process.send === 'function') {
    process.send(JSON.stringify({
      msg: 'exit'
    }));
  }

  (0, _initAbeForProcesses.error)(msg);
  process.exit(0);
});