"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.error = exports.dateStart = void 0;
exports.getTime = getTime;
exports.init = init;
exports.trace = exports.processConfig = exports.log = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _extend = _interopRequireDefault(require("extend"));

var _moment = _interopRequireDefault(require("moment"));

var _debug = _interopRequireDefault(require("debug"));

var Manager = require('../../cli').Manager;

var Handlebars = require('../../cli').Handlebars;

var config = require('../../cli').config;

var abeExtend = require('../../cli').abeExtend;

var log;
exports.log = log;
var trace;
exports.trace = trace;
var error;
exports.error = error;
var processConfig;
exports.processConfig = processConfig;
var dateStart;
exports.dateStart = dateStart;

function getTime() {
  return (0, _moment["default"])((0, _moment["default"])() - dateStart).format('mm:ss') + 'sec';
}

function init(_x, _x2) {
  return _init.apply(this, arguments);
}

function _init() {
  _init = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(processName, conf) {
    return _regenerator["default"].wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            exports.log = log = (0, _debug["default"])(processName + ':log');
            log.color = 2;
            exports.trace = trace = (0, _debug["default"])(processName + ':trace');
            exports.error = error = (0, _debug["default"])(processName + ':error');
            error.color = 1;
            exports.processConfig = processConfig = {};
            Array.prototype.forEach.call(process.argv, function (item) {
              if (item.indexOf('=') > -1) {
                var ar = item.split('=');
                processConfig[ar[0]] = ar[1];
              }
            });

            if (processConfig.ABE_WEBSITE) {
              config.set({
                root: processConfig.ABE_WEBSITE.replace(/\/$/, '') + '/'
              });
            }

            exports.processConfig = processConfig = (0, _extend["default"])(true, conf, processConfig);

            if (!(typeof processConfig.ABE_WEBSITE !== 'undefined' && processConfig.ABE_WEBSITE !== null)) {
              _context.next = 15;
              break;
            }

            abeExtend.hooks.instance.trigger('afterHandlebarsHelpers', Handlebars);
            _context.next = 13;
            return Manager.instance.init();

          case 13:
            _context.next = 17;
            break;

          case 15:
            error('ABE_WEBSITE is not defined use node process.js ABE_WEBSITE=/path/to/website');
            process.exit(0);

          case 17:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));
  return _init.apply(this, arguments);
}