"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _fsExtra = _interopRequireDefault(require("fs-extra"));

var _mkdirp = _interopRequireDefault(require("mkdirp"));

var _path = _interopRequireDefault(require("path"));

var _cli = require("../../cli");

var singleton = Symbol();
var singletonEnforcer = Symbol();

var Manager = /*#__PURE__*/function () {
  function Manager(enforcer) {
    (0, _classCallCheck2["default"])(this, Manager);
    if (enforcer != singletonEnforcer) throw 'Cannot construct Json singleton';
    this._file = _path["default"].join(_cli.config.root, _cli.config.users.path);
  }

  (0, _createClass2["default"])(Manager, [{
    key: "read",
    value:
    /** TODO MONGO */
    function read() {
      if (this.isActive()) {
        if (_cli.coreUtils.file.exist(this._file)) {
          return JSON.parse(_fsExtra["default"].readFileSync(this._file, 'utf8'));
        } else {
          this._users = [];

          var admin = _cli.User.operations.add(_cli.config.users["default"]);

          this.save();

          _cli.User.operations.activate(admin.user.id);

          return JSON.parse(_fsExtra["default"].readFileSync(this._file, 'utf8'));
        }
      }

      return [];
    }
    /** TODO MONGO */

  }, {
    key: "save",
    value: function save() {
      if (this.isActive()) {
        _mkdirp["default"].sync(_path["default"].dirname(this._file));

        _fsExtra["default"].writeJsonSync(this._file, this._users, {
          space: 2,
          encoding: 'utf-8'
        });
      }
    }
    /**
     * TODO MONGO
     */

  }, {
    key: "get",
    value: function get() {
      if (this._users == null) {
        this._users = this.read();
      }

      return this._users;
    }
  }, {
    key: "findById",
    value: function findById(id) {
      var bdd = this.get();
      id = parseInt(id);

      for (var i = 0, len = bdd.length; i < len; i++) {
        var user = bdd[i];

        if (parseInt(user.id) === id) {
          return user;
        }
      }

      return false;
    }
  }, {
    key: "findByEmail",
    value: function findByEmail(email) {
      var bdd = this.get();
      id = parseInt(id);

      for (var i = 0, len = bdd.length; i < len; i++) {
        var user = bdd[i];

        if (user.email === email) {
          return user;
        }
      }

      return false;
    }
  }, {
    key: "findByResetPasswordToken",
    value: function findByResetPasswordToken(resetPasswordToken) {
      var bdd = this.get();
      id = parseInt(id);

      for (var i = 0, len = bdd.length; i < len; i++) {
        var user = bdd[i];

        if (user.resetPasswordToken === resetPasswordToken) {
          return user;
        }
      }

      return false;
    }
    /**
     * TODO MONGO
     * @param {*} json 
     */

  }, {
    key: "update",
    value: function update(json) {
      if (this.isActive()) {
        this._users = json;
        this.save();
        return true;
      }

      return false;
    }
  }, {
    key: "isActive",
    value: function isActive() {
      return _cli.config.users.enable;
    }
  }], [{
    key: "instance",
    get: function get() {
      if (!this[singleton]) {
        this[singleton] = new Manager(singletonEnforcer);
      }

      return this[singleton];
    }
  }]);
  return Manager;
}();

var _default = Manager;
exports["default"] = _default;