"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _path = _interopRequireDefault(require("path"));

var _cli = require("../../cli");

var page = /*#__PURE__*/function () {
  var _ref = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(req, res) {
    var html, json, editor, filepath, jsonPath, linkPath, filePathTest, meta, templateId, text, page, b64str, img;
    return _regenerator["default"].wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            html = req.query.html ? true : false;
            json = null;
            editor = false;

            if (typeof req.body.json !== 'undefined' && req.body.json !== null) {
              editor = true;

              if (typeof req.body.json === 'string') {
                json = JSON.parse(req.body.json);
              } else {
                json = req.body.json;
              }
            }

            filepath = req.originalUrl.replace('/abe/page/', '');

            if (!(typeof filepath !== 'undefined' && filepath !== null)) {
              _context.next = 24;
              break;
            }

            jsonPath = null;
            linkPath = null;
            filePathTest = _cli.cmsData.revision.getDocumentRevision(filepath);

            if (typeof filePathTest !== 'undefined' && filePathTest !== null) {
              jsonPath = filePathTest.path;
              linkPath = filePathTest.abe_meta.link;
            }

            if (!(jsonPath === null)) {
              _context.next = 13;
              break;
            }

            res.status(404).send('Not found');
            return _context.abrupt("return");

          case 13:
            if (!(typeof json === 'undefined' || json === null)) {
              _context.next = 17;
              break;
            }

            _context.next = 16;
            return _cli.cmsData.revision.getDoc(jsonPath);

          case 16:
            json = _context.sent;

          case 17:
            meta = _cli.config.meta.name;
            templateId = '';

            if (json[meta] && json[meta].template) {
              templateId = json[meta].template;
            } else {
              templateId = req.params[0];
            }

            text = _cli.cmsTemplates.template.getTemplate(templateId, json);

            if (!editor) {
              _cli.cmsData.source.updateJsonWithExternalData(text, json).then(function () {
                var page = new _cli.Page(text, json, html);
                res.set('Content-Type', 'text/html');
                res.send(page.html);
              })["catch"](function (e) {
                console.error(e);
              });
            } else {
              text = _cli.cmsData.source.removeDataList(text);
              page = new _cli.Page(text, json, html);
              res.set('Content-Type', 'text/html');
              res.send(page.html);
            }

            _context.next = 25;
            break;

          case 24:
            // not 404 page if tag abe image upload into each block
            if (/upload%20image/g.test(req.url)) {
              b64str = 'data:image/gif;base64,R0lGODlhAQABAAAAACH5BAEKAAEALAAAAAABAAEAAAICTAEAOw==';
              img = new Buffer(b64str, 'base64');
              res.writeHead(200, {
                'Content-Type': 'image/jpeg',
                'Content-Length': img.length
              });
              res.end(img);
            } else {
              res.status(404).send('Not found');
            }

          case 25:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));

  return function page(_x, _x2) {
    return _ref.apply(this, arguments);
  };
}();

var _default = page;
exports["default"] = _default;