"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _package = _interopRequireDefault(require("../../../package"));

var _cli = require("../../cli");

/**
 * This route returns the homepage HTML
 * @param  {[type]}   req  [description]
 * @param  {[type]}   res  [description]
 * @param  {Function} next [description]
 * @return {[type]}        [description]
 */
var route = function route(req, res, next) {
  var manager = {};
  manager.home = {
    files: []
  };
  manager.list = _cli.Manager.instance.getStructureAndTemplates();
  manager.config = JSON.stringify(_cli.config);
  var isDashboard = true;
  var jsonPath = null;
  var linkPath = null;
  var template = null;
  var fileName = null;
  var folderPath = null;

  var files = _cli.Manager.instance.getList();

  var publishedFiles = _cli.Manager.instance.getListWithStatusOnFolder('publish');

  var percent = (publishedFiles.length / files.length * 100).toFixed(1);

  var connectedUsers = _cli.Manager.instance.getConnections();

  var totalUsers = _cli.User.utils.getAll();

  var statistics = {
    totalUsers: totalUsers.length,
    connectedUsers: connectedUsers.length,
    totalPage: files.length,
    totalPublishedPage: publishedFiles.length,
    percentPublishedPages: percent,
    svgCirclePercent: 629 * (percent / 100)
  };
  var EditorVariables = {
    user: res.user,
    slugs: _cli.Manager.instance.getSlugs(),
    filename: fileName,
    folderPath: folderPath,
    abeUrl: '/abe/editor/',
    isDashboard: isDashboard,
    config: _cli.config,
    Locales: _cli.coreUtils.locales.instance.i18n,
    abeVersion: _package["default"].version,
    manager: manager,
    statistics: statistics
  };
  res.render('../views/home', EditorVariables);
};

var _default = route;
exports["default"] = _default;