"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _path = _interopRequireDefault(require("path"));

var _fs = _interopRequireDefault(require("fs"));

var _handlebars = _interopRequireDefault(require("handlebars"));

var _hooks = _interopRequireDefault(require("../../hooks/hooks"));

var _cli = require("../../cli");

/**
 * This route returns the hooks list as html
 * @param  {[type]}   req  [description]
 * @param  {[type]}   res  [description]
 * @param  {Function} next [description]
 * @return {[type]}        [description]
 */
var route = function route(req, res, next) {
  var html = '';

  _cli.abeExtend.hooks.instance.trigger('beforeRoute', req, res, next);

  var page = _path["default"].join(__dirname + '/../views/list-hooks.html');

  if (_cli.coreUtils.file.exist(page)) {
    html = _fs["default"].readFileSync(page, 'utf8');
  }

  var allHooks = [];
  Array.prototype.forEach.call(Object.keys(_hooks["default"]), function (hook) {
    var hookString = _hooks["default"][hook] + '';
    var match = /\((.*?)\)/.exec(hookString);
    var matchReturn = /return ([a-z1-Z-1-9]+)/.exec(hookString);
    allHooks.push({
      name: hook,
      params: match ? match[1] : 'null',
      back: matchReturn ? matchReturn[1].replace(';', '') : 'null'
    });
  });

  var template = _handlebars["default"].compile(html, {
    noEscape: true
  });

  var tmp = template({
    hooks: allHooks
  });
  return res.send(tmp);
};

var _default = route;
exports["default"] = _default;