"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _path = _interopRequireDefault(require("path"));

var _xss = _interopRequireDefault(require("xss"));

var _package = _interopRequireDefault(require("../../../package"));

var _cli = require("../../cli");

var _abeLocale = _interopRequireDefault(require("../helpers/abe-locale"));

function renderAbeAdmin(EditorVariables, obj, filePath) {
  var manager = {};
  manager.home = {
    files: [] //Manager.instance.getList()

  };
  manager.nbPosts = _cli.Manager.instance.getList().length;
  manager.list = _cli.Manager.instance.getStructureAndTemplates();
  manager.editConfig = EditorVariables.express.req.app.get('config');
  manager.config = JSON.stringify(_cli.config);

  var _preview = filePath ? "/abe/page/".concat(EditorVariables.express.req.params[0], "?filePath=").concat(EditorVariables.express.req.query.filePath) : false;

  var _form = obj ? obj.form : false;

  var _json = obj ? obj.json : false;

  var _filePath = filePath ? filePath : false;

  if (_filePath) {
    _filePath = '/' + _filePath.replace(/^\/+/, '');
  }

  var pageHtml = '';

  if (typeof _json !== 'undefined' && _json !== null && typeof _json.abe_meta !== 'undefined' && _json.abe_meta !== null) {
    var text = _cli.cmsTemplates.template.getTemplate(_json.abe_meta.template, _json);

    var page = new _cli.Page(text, _json, false);
    pageHtml = page.html.replace(/"/g, '"').replace(/'/g, "'").replace(/<!--/g, '<ABE!--').replace(/-->/g, '--ABE>');
  }

  var editorWidth = '25%';
  EditorVariables.express.req.headers && EditorVariables.express.req.headers.cookie && EditorVariables.express.req.headers.cookie.split(';').forEach(function (cookie) {
    var parts = cookie.match(/(.*?)=(.*)$/);
    if (typeof parts !== 'undefined' && parts !== null && parts.length > 2 && parts[1] === 'editorWidth') editorWidth = parts[2];
  });
  EditorVariables.pageHtml = pageHtml;
  EditorVariables.test = JSON.stringify(_abeLocale["default"]);
  EditorVariables.text = _abeLocale["default"];
  EditorVariables.preview = _preview;
  EditorVariables.form = _form;
  EditorVariables.json = _json;
  EditorVariables.manager = manager;
  EditorVariables.editorWidth = editorWidth;

  if (_json != null && _json.abe_meta) {
    EditorVariables.workflows = _cli.User.utils.getUserWorkflow(_json.abe_meta.status);
  }

  EditorVariables = _cli.abeExtend.hooks.instance.trigger('afterVariables', EditorVariables);

  if (filePath != null && filePath.indexOf('.json') > -1) {
    EditorVariables.express.res.set('Content-Type', 'application/json');
    EditorVariables.express.res.send(JSON.stringify(_json));
  } else if (EditorVariables.pageHtml != '') {
    EditorVariables.express.res.render(_cli.config.abeEngine, EditorVariables);
  } else {
    EditorVariables.express.res.render('../views/manager', EditorVariables);
  }
}
/**
 * This route returns the editor page as HTML
 * @param  {[type]}   req  [description]
 * @param  {[type]}   res  [description]
 * @param  {Function} next [description]
 * @return {[type]}        [description]
 */


var route = /*#__PURE__*/function () {
  var _ref = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2(req, res, next) {
    var filePath, isHome, jsonPath, template, fileName, folderPath, EditorVariables, obj, filePathTest, json, text, precontribs;
    return _regenerator["default"].wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            filePath = req.originalUrl.replace('/abe/editor/', '');

            if (filePath === '/abe' || filePath === '/abe/') {
              filePath = filePath.replace('/abe', '');
            }

            if (filePath === '' || filePath === '/') {
              filePath = null;
            }

            if (!(filePath != null && _path["default"].extname(filePath) != ".".concat(_cli.config.files.templates.extension) && _path["default"].extname(filePath) != '.json')) {
              _context2.next = 6;
              break;
            }

            next();
            return _context2.abrupt("return");

          case 6:
            // if (filePath != null) {
            //   var filePath = xss(filePath, {
            //     whiteList: [],
            //     stripIgnoreTag: true
            //   })
            //   if (testXSS !== filePath) {
            //     filePath = testXSS
            //   }
            // }
            _cli.abeExtend.hooks.instance.trigger('beforeRoute', req, res, next);

            if (!(typeof res._header !== 'undefined' && res._header !== null)) {
              _context2.next = 9;
              break;
            }

            return _context2.abrupt("return");

          case 9:
            isHome = true;
            jsonPath = null;
            template = null;
            fileName = null;
            folderPath = null;
            EditorVariables = {
              user: res.user,
              slugs: _cli.Manager.instance.getSlugs(),
              express: {
                res: res,
                req: req
              },
              filename: fileName,
              folderPath: folderPath,
              abeUrl: '/abe/editor/',
              isHome: isHome,
              config: _cli.config,
              Locales: _cli.coreUtils.locales.instance.i18n,
              abeVersion: _package["default"].version
            };
            obj = {
              json: {},
              manager: {}
            };

            if (!(filePath != null)) {
              _context2.next = 33;
              break;
            }

            fileName = _path["default"].basename(filePath);
            folderPath = _path["default"].dirname(filePath);
            EditorVariables.isHome = false;
            EditorVariables.isEditor = true;
            filePathTest = _cli.cmsData.revision.getDocumentRevision(filePath);

            if (typeof filePathTest !== 'undefined' && filePathTest !== null) {
              jsonPath = filePathTest.path;
              template = filePathTest.abe_meta.template;
            }

            if (!(jsonPath === null)) {
              _context2.next = 26;
              break;
            }

            res.redirect('/abe/editor');
            return _context2.abrupt("return");

          case 26:
            _context2.next = 28;
            return _cli.cmsData.revision.getDoc(jsonPath);

          case 28:
            json = _context2.sent;
            text = _cli.cmsTemplates.template.getTemplate(template, json);
            _context2.next = 32;
            return _cli.cmsEditor.editor.create(text, json)["catch"](function (e) {
              console.error(e);
            });

          case 32:
            obj = _context2.sent;

          case 33:
            precontribs = _cli.Manager.instance.getPrecontribution();
            EditorVariables.resultPrecontrib = [];

            if (!(precontribs != null)) {
              _context2.next = 38;
              break;
            }

            _context2.next = 38;
            return Promise.all(precontribs.map( /*#__PURE__*/function () {
              var _ref2 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(precontrib) {
                var resultPrecontrib;
                return _regenerator["default"].wrap(function _callee$(_context) {
                  while (1) {
                    switch (_context.prev = _context.next) {
                      case 0:
                        _context.next = 2;
                        return _cli.cmsEditor.editor.create(precontrib, obj.json, true)["catch"](function (e) {
                          console.error(e);
                        });

                      case 2:
                        resultPrecontrib = _context.sent;
                        EditorVariables.resultPrecontrib.push(resultPrecontrib);

                      case 4:
                      case "end":
                        return _context.stop();
                    }
                  }
                }, _callee);
              }));

              return function (_x4) {
                return _ref2.apply(this, arguments);
              };
            }()));

          case 38:
            renderAbeAdmin(EditorVariables, obj, filePath, isHome, template);

          case 39:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));

  return function route(_x, _x2, _x3) {
    return _ref.apply(this, arguments);
  };
}();

var _default = route;
exports["default"] = _default;