"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _fsExtra = _interopRequireDefault(require("fs-extra"));

var _path = _interopRequireDefault(require("path"));

var _package = _interopRequireDefault(require("../../../package"));

var _cli = require("../../cli");

/**
 * This route returns the references files in HTML format
 * @param  {[type]} req [description]
 * @param  {[type]} res [description]
 * @return {[type]}     [description]
 */
var route = function route(req, res) {
  var manager = {};
  manager.home = {
    files: []
  };
  manager.list = _cli.Manager.instance.getStructureAndTemplates();
  manager.config = JSON.stringify(_cli.config);
  var isHome = true;
  var jsonPath = null;
  var linkPath = null;
  var template = null;
  var fileName = null;
  var folderPath = null;
  var EditorVariables = {
    user: res.user,
    slugs: _cli.Manager.instance.getSlugs(),
    abeUrl: '/abe/themes/',
    Locales: _cli.coreUtils.locales.instance.i18n,
    manager: manager,
    config: _cli.config,
    reference: _cli.Manager.instance.getReferences(),
    isThemes: true,
    abeVersion: _package["default"].version
  };

  _cli.cmsThemes.themes.getThemeInfos().then(function (json) {
    EditorVariables['theme'] = json;
    res.render('../views/themes.html', EditorVariables);
  });
};

var _default = route;
exports["default"] = _default;