"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof3 = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));

var _getMain = _interopRequireDefault(require("./get-main"));

var _postListUrlSave = _interopRequireDefault(require("./post-list-url-save"));

var _getListUrl = _interopRequireDefault(require("./get-list-url"));

var _getListWorkflow = _interopRequireDefault(require("./get-list-workflow"));

var _getListHooks = _interopRequireDefault(require("./get-list-hooks"));

var _getPage = _interopRequireDefault(require("./get-page"));

var _postPage = _interopRequireDefault(require("./post-page"));

var _getGeneratePosts = _interopRequireDefault(require("./get-generate-posts"));

var _getSaveConfig = _interopRequireDefault(require("./get-save-config"));

var _postUpload = _interopRequireDefault(require("./post-upload"));

var _postSqlRequest = _interopRequireDefault(require("./post-sql-request"));

var _postReference = _interopRequireDefault(require("./post-reference"));

var _getReference = _interopRequireDefault(require("./get-reference"));

var _postStructure = _interopRequireDefault(require("./post-structure"));

var _getStructure = _interopRequireDefault(require("./get-structure"));

var _getPaginate = _interopRequireDefault(require("./get-paginate"));

var _getThumbs = _interopRequireDefault(require("./get-thumbs"));

var _getImage = _interopRequireDefault(require("./get-image"));

var _getHome = _interopRequireDefault(require("./get-home"));

var _getThemes = _interopRequireDefault(require("./get-themes"));

var _getBuildTemplate = _interopRequireDefault(require("./get-build-template"));

var _postBuildTemplate = _interopRequireDefault(require("./post-build-template"));

var _postThemes = _interopRequireDefault(require("./post-themes"));

var users = _interopRequireWildcard(require("./users"));

var operations = _interopRequireWildcard(require("./operations"));

var rest = _interopRequireWildcard(require("./rest"));

var _express = _interopRequireDefault(require("express"));

var abe = _interopRequireWildcard(require("../../cli"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof3(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var router = _express["default"].Router();

abe.abeExtend.hooks.instance.trigger('afterHandlebarsHelpers', abe.Handlebars);
abe.abeExtend.hooks.instance.trigger('beforeAddRoute', router);
router.get('/abe/rest/posts*', rest.posts);
router.get('/abe/rest/post*', rest.post);
router.get('/abe/rest/activity-stream', rest.activityStream);
router.post('/abe/rest/authenticate', rest.authenticate);
router.get('/abe/users/forgot', users.getForgot);
router.get('/abe/users/list', users.getList);
router.get('/abe/users/login', users.getLogin);
router.get('/abe/users/logout', users.getLogout);
router.get('/abe/users/reset', users.getReset);
router.get('/abe/users/profile', users.getProfile);
router.post('/abe/users/activate', users.postActivate);
router.post('/abe/users/add', users.postAdd);
router.post('/abe/users/deactivate', users.postDeactivate);
router.post('/abe/users/login', users.postLogin);
router.post('/abe/users/remove', users.postRemove);
router.post('/abe/users/reset', users.postReset);
router.post('/abe/users/update', users.postUpdate);
router.post('/abe/users/profile', users.postProfile);
router.post('/abe/users/save-search', users.postSaveSearch);
router.post('/abe/users/remove-search', users.postRemoveSearch);
router.get('/abe/paginate', _getPaginate["default"]);
router.post('/abe/sql-request*', _postSqlRequest["default"]);
router.post('/abe/page/*', _postPage["default"]);
router.get('/abe/page/*', _getPage["default"]);
router.get('/abe/generate-posts', _getGeneratePosts["default"]);
router.get('/abe/save-config', _getSaveConfig["default"]);
router.get('/abe/reference', _getReference["default"]);
router.get('/abe/structure', _getStructure["default"]);
router.get('/abe/thumbs/*', _getThumbs["default"]);
router.get('/abe/image/*', _getImage["default"]);
router.post('/abe/upload/*', _postUpload["default"]);
router.post('/abe/reference/*', _postReference["default"]);
router.post('/abe/structure/*', _postStructure["default"]);
router.get('/abe/editor*', _getMain["default"]);
router.post('/abe/list-url/save*', _postListUrlSave["default"]);
router.get('/abe/themes', _getThemes["default"]);
router.post('/abe/themes', _postThemes["default"]);
router.get('/abe/build-template', _getBuildTemplate["default"]);
router.post('/abe/build-template', _postBuildTemplate["default"]);
router.get('/abe/list-workflow*', function (req, res, next) {
  (0, _getListWorkflow["default"])(router, req, res, next);
});
router.get('/abe/list-url*', function (req, res, next) {
  (0, _getListUrl["default"])(router, req, res, next);
});
router.get('/abe/list-hooks*', _getListHooks["default"]);
/**
 * Operations
 * - create : create a post
 * - update : update a post, changing its name (or path or template)
 * - delete : delete a post
 * - duplicate : duplicate a revision
 * - reject : reject a workflow step (else but the publish)
 * - unpublish : unpublish a published post (=== reject a published post)
 * - submit : submit a workflow step (including draft and publish)
 * - edit : save a post keeping it in its status
 */

router.post('/abe/operations/create*', operations.postCreate);
router.post('/abe/operations/duplicate*', operations.postDuplicate);
router.post('/abe/operations/update*', operations.postUpdate);
var workflows = abe.config.users.workflow;
Array.prototype.forEach.call(workflows, function (workflow) {
  router.get("/abe/operations/delete/".concat(workflow, "*"), operations.getDelete);

  if (workflow != 'draft' && workflow != 'publish') {
    router.post("/abe/operations/reject/".concat(workflow, "*"), operations.postReject);
  } else if (workflow == 'publish') {
    router.get('/abe/operations/unpublish*', operations.getUnpublish);
  }

  router.post("/abe/operations/submit/".concat(workflow, "*"), operations.postSubmit);
  router.post("/abe/operations/edit/".concat(workflow, "*"), operations.postEdit);
});
var routes = abe.abeExtend.plugins.instance.getRoutes();
Array.prototype.forEach.call(routes, function (route) {
  if (typeof route.get !== 'undefined' && route.get !== null) {
    Array.prototype.forEach.call(route.get, function (routeGet) {
      try {
        var pluginRoot = require(routeGet.path);

        if ((0, _typeof2["default"])(pluginRoot["default"]) === 'object') {
          if (typeof pluginRoot.middleware === 'function') {
            router.get(routeGet.routePath, pluginRoot.middleware, pluginRoot["default"]);
          } else {
            router.get(routeGet.routePath, pluginRoot["default"]);
          }
        } else {
          if (typeof pluginRoot.middleware === 'function') {
            router.get(routeGet.routePath, pluginRoot.middleware, function (req, res, next) {
              pluginRoot["default"](req, res, next, abe);
            });
          } else {
            router.get(routeGet.routePath, function (req, res, next) {
              pluginRoot["default"](req, res, next, abe);
            });
          }
        }
      } catch (e) {
        // statements
        console.log(e);
      }
    });
  }

  if (typeof route.post !== 'undefined' && route.post !== null) {
    Array.prototype.forEach.call(route.post, function (routePost) {
      //console.log(routePost.path)
      try {
        var pluginRoot = require(routePost.path);

        if ((0, _typeof2["default"])(pluginRoot["default"]) === 'object') {
          if (typeof pluginRoot.middleware === 'function') {
            router.post(routePost.routePath, pluginRoot.middleware, pluginRoot["default"]);
          } else {
            router.post(routePost.routePath, pluginRoot["default"]);
          }
        } else {
          if (typeof pluginRoot.middleware === 'function') {
            router.post(routePost.routePath, pluginRoot.middleware, function (req, res, next) {
              pluginRoot["default"](req, res, next, abe);
            });
          } else {
            router.post(routePost.routePath, function (req, res, next) {
              pluginRoot["default"](req, res, next, abe);
            });
          }
        }
      } catch (e) {
        // statements
        console.log(e);
      }
    });
  }
});
abe.abeExtend.hooks.instance.trigger('afterAddRoute', router);
var _default = router;
exports["default"] = _default;