"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _path = _interopRequireDefault(require("path"));

var _cli = require("../../cli");

var route = function route(req, res) {
  if (typeof res._header !== 'undefined' && res._header !== null) return;

  _cli.cmsReference.reference.saveFile(req.body.url, req.body.json);

  if (_cli.config.publish['auto-republish'] && _cli.config.publish['auto-republish'].active) {
    var nbPosts = _cli.Manager.instance.getList().length;

    if (_cli.config.publish['auto-republish'].limit >= nbPosts) {
      var generateArgs = [];
      generateArgs.push("ABE_DESTINATION=".concat(_path["default"].relative(_cli.config.root, _cli.Manager.instance.pathPublish)));

      var proc = _cli.abeExtend.process('generate-posts', generateArgs, function (data) {
        res.app.emit('generate-posts', data);
      });

      if (proc) {
        res.app.emit('generate-posts', {
          percent: 0,
          time: '00:00sec'
        });
        console.log('generate-posts emitted');
      }
    }
  }

  res.set('Content-Type', 'application/json');
  res.send(JSON.stringify({
    success: 1
  }));
};

var _default = route;
exports["default"] = _default;