"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _path = _interopRequireDefault(require("path"));

var _url = _interopRequireDefault(require("url"));

var _cli = require("../../cli");

var route = function route(req, res, next) {
  _cli.abeExtend.hooks.instance.trigger('beforeRoute', req, res, next);

  if (typeof res._header !== 'undefined' && res._header !== null) return;
  var sourceString = req.body.sourceString;
  var prefillQuantity = req.body.prefillQuantity != null && req.body.prefillQuantity != 'null' ? "prefill-quantity=\"".concat(req.body.prefillQuantity, "\"") : '';
  var key = req.body.key;
  var jsonPage = req.body.json ? JSON.parse(JSON.stringify(req.body.json)) : {
    abe_meta: {}
  };
  jsonPage.abe_meta.link = _url["default"].parse(req.header('referer')).path.replace('/abe/editor', '');
  jsonPage[key] = null;
  var request = "{{abe type=\"data\" key=\"".concat(key, "\" source=\"").concat(sourceString, "\" prefill=\"true\" ").concat(prefillQuantity, " editable=\"true\"}}");

  var obj = _cli.cmsData.attributes.getAll(request, jsonPage);

  _cli.cmsData.source.requestList(obj, request, jsonPage).then(function () {
    res.set('Content-Type', 'application/json');
    res.send(JSON.stringify(jsonPage[key]));
  });
};

var _default = route;
exports["default"] = _default;