"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _package = _interopRequireDefault(require("../../../../../package"));

var _fsExtra = _interopRequireDefault(require("fs-extra"));

var _path = _interopRequireDefault(require("path"));

var _cli = require("../../../../cli");

var route = function route(req, res) {
  var resHtml = '';

  var page = _path["default"].join(__dirname + '/../../../views/users/users-list.html');

  if (_cli.coreUtils.file.exist(page)) {
    resHtml = _fsExtra["default"].readFileSync(page, 'utf8');
  }

  var template = _cli.Handlebars.compile(resHtml, {
    noEscape: true
  });

  var roles = _cli.config.users.roles;
  var tmp = template({
    users: _cli.User.utils.getAll(),
    user: res.user,
    config: _cli.config,
    roles: roles,
    isMembers: true,
    manager: {
      config: JSON.stringify(_cli.config)
    },
    abeVersion: _package["default"].version
  });
  return res.send(tmp);
};

var _default = route;
exports["default"] = _default;