"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _package = _interopRequireDefault(require("../../../../../package"));

var _fsExtra = _interopRequireDefault(require("fs-extra"));

var _path = _interopRequireDefault(require("path"));

var _cli = require("../../../../cli");

var route = function route(req, res) {
  var resHtml = '';

  var page = _path["default"].join(__dirname + '/../../../views/users/profile.html');

  if (_cli.coreUtils.file.exist(page)) {
    resHtml = _fsExtra["default"].readFileSync(page, 'utf8');
  }

  var template = _cli.Handlebars.compile(resHtml, {
    noEscape: true
  });

  var userEditable = JSON.parse(JSON.stringify(res.user));
  delete userEditable.password;
  delete userEditable.role;
  delete userEditable.id;
  delete userEditable.actif;
  var tmp = template({
    csrfToken: res.locals.csrfToken,
    config: _cli.config,
    userEditable: userEditable,
    express: {
      req: req,
      res: res
    },
    info: req.flash('info'),
    error: req.flash('error'),
    isProfile: true,
    user: res.user,
    manager: {
      config: JSON.stringify(_cli.config)
    },
    abeVersion: _package["default"].version
  });
  return res.send(tmp);
};

var _default = route;
exports["default"] = _default;