"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _fsExtra = _interopRequireDefault(require("fs-extra"));

var _path = _interopRequireDefault(require("path"));

var _cli = require("../../../../cli");

var route = function route(req, res) {
  var resHtml = '';

  if (typeof req.query.token !== 'undefined' && req.query.token !== null) {
    _cli.User.utils.findByResetPasswordToken(req.query.token, function () {
      var page = _path["default"].join(__dirname + '/../../../views/users/reset.html');

      if (_cli.coreUtils.file.exist(page)) {
        resHtml = _fsExtra["default"].readFileSync(page, 'utf8');
      }

      var template = _cli.Handlebars.compile(resHtml, {
        noEscape: true
      });

      var tmp = template({
        csrfToken: res.locals.csrfToken,
        config: JSON.stringify(_cli.config),
        express: {
          req: req,
          res: res
        },
        token: req.query.token,
        info: req.flash('info')
      });
      return res.send(tmp);
    });
  } else {
    res.redirect('/abe/users/forgot');
  }
};

var _default = route;
exports["default"] = _default;