"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _cli = require("../../../../cli");

var route = function route(req, res) {
  var decoded = _cli.User.utils.decodeUser(req, res);

  var user = _cli.User.utils.findSync(decoded.iss);

  var body = req.body;

  if (body.oldpassword != null && body.oldpassword != '' && body.password != null && body.password != '' && body['repeat-password'] != null && body['repeat-password'] != '') {
    if (body.password !== body['repeat-password']) {
      req.flash('error', 'password must be the same');
      return res.redirect('/abe/users/profile');
    }

    if (!_cli.User.utils.isValid(user, body.oldpassword)) {
      req.flash('error', 'Wrong password');
      return res.redirect('/abe/users/profile');
    } else {
      var toUpdate = {
        id: user.id,
        password: body.password,
        username: user.username
      };

      var resultUpdatePassword = _cli.User.operations.updatePassword(toUpdate, toUpdate.password);

      if (resultUpdatePassword.success === 0) {
        req.flash('error', resultUpdatePassword.message);
        return res.redirect('/abe/users/profile');
      }
    }
  }

  delete body.password;
  delete body._csrf;
  delete body.oldpassword;
  delete body['repeat-password'];
  body.id = user.id;

  var resultUpdate = _cli.User.operations.update(body);

  req.flash('info', 'Profile updated');
  return res.redirect('/abe/users/profile');
};

var _default = route;
exports["default"] = _default;