import Cookies from 'cookies'
import jwt from 'jwt-simple'

import {config, User} from '../../../'

export default function getCurrentuserRole(obj) {
  if (typeof obj.express !== 'undefined' && obj.express !== null) {
    var cookies = new Cookies(obj.express.req, obj.express.res, {
      secure: config.cookie.secure
    })
    var token = cookies.get('x-access-token')
    if (typeof token !== 'undefined' && token !== null && token !== '') {
      var secret = config.users.secret
      var decoded = jwt.decode(token, secret)
      var user = User.utils.findSync(decoded.iss)
      if (user && user.role) return user.role.workflow

      return null
    }
  }
  return ''
}
